<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/userguide3/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'Front_controller';
$route['index'] = 'Front_controller/index';
$route['esim/(:any)'] = 'Front_controller/country_details/$1';
$route['country-details'] = 'Front_controller/country_details';

$route['faq'] = 'Front_controller/faq';

$route['esimdevices'] = 'Front_controller/esimdevices';
$route['termcondition'] = 'Front_controller/termcondition';
$route['refundpolicy'] = 'Front_controller/refundpolicy';
$route['privacypolicy'] = 'Front_controller/privacypolicy';
$route['about'] = 'Front_controller/about'; 
$route['contact'] = 'Front_controller/contact';
$route['blog'] = 'Blog_controller/index'; 
$route['view-blog'] = 'Blog_controller/blog_details';
$route['partner-with-us'] = 'Front_controller/partner_with_us';
$route['cart'] = 'Front_controller/cart';

$route['checkout'] = 'Payment_controller/index'; 
$route['stripePayment/(:num)'] = 'Payment_controller/gotoStripePayment/$1';
$route['paywithpaypal/(:num)'] = 'Payment_controller/paypal/$1';
$route['success/(:any)/(:any)'] = 'Payment_controller/success/$1/$2'; 
$route['cancel'] = 'Payment_controller/cancel'; 
$route['pay-success'] = 'Payment_controller/pay_success';
$route['pay-cancel'] = 'Payment_controller/pay_cancel';
$route['pay-ipn'] = 'Paypal/ipn';
$route['authuser'] = 'Front_controller/authuser';
$route['logout'] = 'Front_controller/logout';
$route['registeruser'] = 'Front_controller/registeruser';

// User profile
$route['profile'] = 'User_controller/index'; 

// Admin Panel
$route['admin-auth'] = 'Login_controller/index'; 
$route['admin-logout'] = 'Login_controller/logout'; 
$route['admin-profile'] = 'Login_controller/profile';
$route['admin-settings'] = 'Login_controller/settings';
$route['admin-index'] = 'Home_controller/index';
$route['admin-region'] = 'Home_controller/region';
$route['admin-region/(:num)'] = 'Home_controller/region/$1';
$route['admin-country'] = 'Home_controller/country';
$route['admin-country/(:num)'] = 'Home_controller/country/$1';

$route['admin-index-banner'] = 'Home_controller/index_banner';
$route['admin-faq'] = 'Home_controller/faq';
$route['admin-faq/(:num)'] = 'Home_controller/faq/$1';

$route['admin-termscondition'] = 'Home_controller/termscondition';
$route['admin-privacypolicy'] = 'Home_controller/privacypolicy';
$route['admin-refundpolicy'] = 'Home_controller/privacypolicy';

$route['admin-plan'] = 'Home_controller/plan';
$route['admin-plan/(:num)'] = 'Home_controller/plan/$1';
$route['admin-add-plan'] = 'Home_controller/add_plan';
$route['admin-edit-plan/(:num)'] = 'Home_controller/edit_plan/$1';  

$route['admin-rechargable-topup'] = 'Home_controller/rechargable_topup';
$route['admin-rechargable-topup/(:num)'] = 'Home_controller/rechargable_topup/$1';
$route['admin-create-topup'] = 'Home_controller/create_topup';
$route['admin-create-topup/(:num)'] = 'Home_controller/create_topup/$1';

$route['admin-order-set'] = 'Home_controller/order_set';
$route['admin-order-set/(:num)'] = 'Home_controller/order_set/$1';

$route['admin-supplier'] = 'Home_controller/supplier';
$route['admin-supplier/(:num)'] = 'Home_controller/supplier/$1';
$route['admin-add-supplier'] = 'Home_controller/add_supplier';
$route['admin-edit-supplier/(:num)'] = 'Home_controller/edit_supplier/$1';

$route['admin-operator'] = 'Home_controller/operator';
$route['admin-operator/(:num)'] = 'Home_controller/operator/$1';
$route['admin-add-operator'] = 'Home_controller/add_operator';
$route['admin-edit-operator/(:num)'] = 'Home_controller/edit_operator/$1';

$route['admin-affiliate'] = 'Home_controller/affiliate';
$route['admin-affiliate/(:num)'] = 'Home_controller/affiliate/$1';

$route['admin-enquiries'] = 'Home_controller/enquiries';
$route['admin-enquiries/(:num)'] = 'Home_controller/enquiries/$1';

$route['admin-partner'] = 'Home_controller/partner';
$route['admin-partner/(:num)'] = 'Home_controller/partner/$1';
$route['admin-add-partner'] = 'Home_controller/add_partner';
$route['admin-add-partner/(:num)'] = 'Home_controller/add_partner/$1';
$route['admin-edit-partner/(:num)'] = 'Home_controller/edit_partner/$1';

$route['admin-partner-enquiries'] = 'Home_controller/partner_enquiries';
$route['admin-partner-enquiries/(:num)'] = 'Home_controller/partner_enquiries/$1';

$route['admin-complaint'] = 'Home_controller/complaint';
$route['admin-complaint/(:num)'] = 'Home_controller/complaint/$1';

$route['admin-sub-complaint'] = 'Home_controller/sub_complaint';
$route['admin-sub-complaint/(:num)'] = 'Home_controller/sub_complaint/$1';

$route['admin-tickets'] = 'Home_controller/tickets';
$route['admin-tickets/(:num)'] = 'Home_controller/tickets/$1';
$route['admin-view-ticket/(:num)'] = 'Home_controller/view_ticket/$1';

$route['admin-esimdevices'] = 'Home_controller/esimdevices';
$route['admin-esimdevices/(:num)'] = 'Home_controller/esimdevices/$1';

$route['admin'] = 'users/admin-list';
$route['user'] = 'users/user-list';
$route['vendor'] = 'users/vendor-list';
  
$route['admin-reports'] = 'Home_controller/reports';
$route['admin-sale-report'] = 'Home_controller/sale_report';
$route['admin-sale-report/(:num)'] = 'Home_controller/sale_report/$1';
$route['admin-website-inventory-report'] = 'Home_controller/website_inventory_report';
$route['admin-website-inventory-report/(:num)'] = 'Home_controller/website_inventory_report/$1';
$route['admin-signup-report'] = 'Home_controller/signup_report';
$route['admin-signup-report/(:num)'] = 'Home_controller/signup_report/$1';

$route['admin-payments'] = 'Home_controller/payments';
$route['admin-payments/(:num)'] = 'Home_controller/payments/$1';

$route['admin-coupon'] = 'Home_controller/coupon';
$route['admin-coupon/(:num)'] = 'Home_controller/coupon/$1';
$route['admin-add-coupon'] = 'Home_controller/add_coupon';
$route['admin-edit-coupon/(:num)'] = 'Home_controller/edit_coupon/$1';

$route['admin-network'] = 'Home_controller/network';
$route['admin-network/(:num)'] = 'Home_controller/network/$1';

$route['admin-kyc-user'] = 'Home_controller/kyc_users'; 
$route['admin-kyc-user/(:num)'] = 'Home_controller/kyc_users/$1';
$route['admin-kyc-sale'] = 'Home_controller/kyc_sale'; 
$route['admin-kyc-sale/(:num)'] = 'Home_controller/kyc_sale/$1';
$route['admin-kyc-user-details/(:num)'] = 'Home_controller/kyc_user_details/$1';

$route['admin-api-sale'] = 'Home_controller/api_sale';
$route['admin-api-sale/(:num)'] = 'Home_controller/api_sale/$1';

$route['admin-inventory-quick-tool'] = 'Home_controller/inventory_quick_tool';
$route['admin-inventory-quick-tool/(:num)'] = 'Home_controller/inventory_quick_tool/$1';
$route['admin-add-inventory'] = 'Home_controller/add_inventory';
$route['admin-add-inventory/(:num)'] = 'Home_controller/add_inventory/$1'; 

$route['admin-create-offline-customer'] = 'Home_controller/create_offline_customer';
$route['admin-create-offline-customer/(:num)'] = 'Home_controller/create_offline_customer/$1';

$route['admin-create-offline-plan'] = 'Home_controller/create_offline_plan';
$route['admin-create-offline-plan/(:num)'] = 'Home_controller/create_offline_plan/$1';

$route['admin-offline-plan'] = 'Home_controller/offline_plan';
$route['admin-offline-plan/(:num)'] = 'Home_controller/offline_plan/$1'; 

$route['admin-offline-sale-report'] = 'Home_controller/offline_sale_report';
$route['admin-offline-sale-report/(:num)'] = 'Home_controller/offline_sale_report/$1';

$route['admin-data-sync'] = 'Home_controller/data_sync';
$route['admin-data-sync/(:num)'] = 'Home_controller/data_sync/$1';

$route['admin-orders'] = 'Home_controller/orders';
$route['admin-orders/(:num)'] = 'Home_controller/orders/$1';


$route['admin-offers'] = 'Home_controller/banner_offers';
$route['admin-offers/(:num)'] = 'Home_controller/banner_offers/$1';
$route['admin-add-offer'] = 'Home_controller/add_offer';
$route['admin-add-offer/(:num)'] = 'Home_controller/add_offer/$1';

$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;
