<?php
date_default_timezone_set('Asia/Kolkata');
require FCPATH.'vendor/autoload.php';
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

class Home_controller extends My_Controller{

    
    function __construct()
    {
        parent::__construct();
		$this->page_segment = 2;
        $this->per_page = 100;
        $this->per_page_option = array(20=>20,50=>50, 100=>100, 500=>500); 
        
        $this->load->helper('common_helper'); 
        if ($this->session->userdata('userID')=="") {
            redirect(base_url('admin-auth'));
        }     
    }

    public function index(){
        $data['no_of_active_plans'] = $this->Home_model->no_of_active_plans();
        $data['no_of_orders'] = $this->Home_model->no_of_orders();
        $data['no_of_enquiries'] = $this->Home_model->no_of_enquiries();
        $data['no_of_inventory'] = $this->Home_model->no_of_inventoty();
        $this->load->view('admin/dashboard',$data);
    }

    
    public function region(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'r_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallregions('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallregions('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-region/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/region',
            'default_sort'      => 'r_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/region_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_region(){
        $banner_image = "";
        if(!empty($_FILES['region_banner']['name'])){
                
            $config['upload_path']      = "assets/images/regions";
            $config['allowed_types']    = "png|jpg|jpeg|gif|webp";
            $config['encrypt_name']     =  TRUE;
            $config['overwrite']        =  TRUE;
         
            $this->load->library('upload', $config);
            $this->upload->initialize($config);
            if(!$this->upload->do_upload('region_banner'))
                {
                    $error  = array('error'  => $this->upload->display_errors());
                    
                }
                else
                {
                    $banner_image  = $this->upload->data('file_name');
                    //echo "ok"; print_r($uploadedImage);die;
                }
        }
        $res = $this->Home_model->add_region($banner_image);
        echo json_encode($res);
    }

    public function delete_region() {
        $id = $this->input->post('new_id');
        $res = $this->Home_model->delete_region_byID($id);
        echo json_encode($res);
    }

    public function get_region_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['region'] = $this->Home_model->get_region_byID();

            parent::s_render('admin/add_region',$data);
            
        }
    }

    public function country(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'country_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        
        $data['region_list'] = $this->Home_model->getRegionList();
        $data['data'] = $this->Home_model->getallCountries('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallCountries('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-country/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/country',
            'default_sort'      => 'country_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/country_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function check_country(){
        $id = $this->input->post('cont');
        $data = $this->Home_model->check_country($id);
        echo json_encode($data);
    }

    public function add_country(){
        //echo '<pre>'; print_r($this->input->post());die;
        $uploadedImage = "";
        if(!empty($_FILES['country_logo']['name'])){
                
                $config['upload_path']      = "assets/images/countries";
                $config['allowed_types']    = "png|jpg|jpeg|gif";
                $config['encrypt_name']     =  true;
                $config['overwrite']        =  TRUE;
             
                $this->load->library('upload', $config);
                $this->upload->initialize($config);
                if(!$this->upload->do_upload('country_logo'))
                    {
                        $error  = array('error'  => $this->upload->display_errors());
                        
                    }
                    else
                    {
                        $uploadedImage  = $this->upload->data('file_name');
                        //echo "ok"; print_r($uploadedImage);die;
                    }
        }
        $res = $this->Home_model->add_country($uploadedImage);
        echo json_encode($res);
    }

    public function get_country_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['countries'] = $this->Home_model->get_country_byID();
            $data['region_list'] = $this->Home_model->getRegionList();
            parent::s_render('admin/add_country',$data);
            
        }
    }

    public function delete_country(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_country_byID($id);
        echo json_encode($data);
    }

    public function getcountrylist(){
       $countries = $this->Home_model->countryList();
       echo json_encode($countries);
    }

    public function getregionlist(){
        $regions  = $this->Home_model->getRegionList();
        echo json_encode($regions);
    }

    public function plan(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pl_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallplans('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallplans('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-plan/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/plan',
            'default_sort'      => 'pl_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/plan_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_plan(){
        $data['countries'] = $this->Home_model->countryList();
        $data['suppliers'] = $this->Home_model->supplierList();
        $data['guidelines'] = $this->Home_model->guidlineList();
        $data['regions'] = $this->Home_model->getRegionList();

        $this->load->view('admin/add_plan',$data);
    }

    public function add_new_plan(){
        $result = $this->Home_model->add_plan();
        echo json_encode($result);
       
    }

    public function delete_plan(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_plan_byID($id);
        echo json_encode($data);
    }

    public function change_plan_status(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->change_plan_status_byID($id);
        echo json_encode($data);
    }

    public function edit_plan(){
        $id = $this->uri->segment(2);
        $data['countries'] = $this->Home_model->countryList();
        $data['regions'] = $this->Home_model->getRegionList();
        $data['suppliers'] = $this->Home_model->supplierList();
        $data['guidelines'] = $this->Home_model->guidlineList();
        $data['type'] = 'edit';
        $data['plan_details'] = $this->Home_model->get_plan_byID($id);
        $this->load->view('admin/add_plan',$data);
    }

    public function edit_plan_by_id(){
       
        $result = $this->Home_model->add_plan();
        echo json_encode($result);
       
    }

    public function export_plans_list(){
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        $export_data = $this->Home_model->getallplans('data',$where_data);
        //echo '<pre>'; print_r($export_data); die;
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="plans-list.xlsx"');
        $spreadsheet = new Spreadsheet();
        $activeWorksheet = $spreadsheet->getActiveSheet();
        $activeWorksheet->setCellValue('A1', 'Srno');
        $activeWorksheet->setCellValue('B1', 'Property Type');
        $activeWorksheet->setCellValue('C1', 'Plan Code');
        $activeWorksheet->setCellValue('D1', 'Plan Class');
        $activeWorksheet->setCellValue('E1', 'Plan Name');
        $activeWorksheet->setCellValue('F1', 'Supplier');
        $activeWorksheet->setCellValue('G1', 'Geography');
        $activeWorksheet->setCellValue('H1', 'Plan Type');
        $activeWorksheet->setCellValue('I1', 'Data');
        $activeWorksheet->setCellValue('J1', 'Validity');
        $activeWorksheet->setCellValue('K1', 'Rechargable');
        $activeWorksheet->setCellValue('L1', 'Usage Policy');
        $activeWorksheet->setCellValue('M1', 'Buying Cost');
        $activeWorksheet->setCellValue('N1', 'Voice Minutes');
        $activeWorksheet->setCellValue('O1', 'Internet Breakout');
        $activeWorksheet->setCellValue('P1', 'Top Seller');
        $activeWorksheet->setCellValue('Q1', 'Best Seller');
        $activeWorksheet->setCellValue('R1', 'APN');
        $activeWorksheet->setCellValue('S1', 'Per GB Value');
        $activeWorksheet->setCellValue('T1', 'Per MB Value');
        $activeWorksheet->setCellValue('U1', 'Throttle Speed');
        $activeWorksheet->setCellValue('V1', 'Stock Value');
        $activeWorksheet->setCellValue('W1', 'Status');
        if(!empty($export_data) && $export_data!=""){
            $sn = 1; $sheet_cnt = 2;
            foreach($export_data as $list){ $geography = $ptype = $pclass = $type = $policy = $isRechargable = $breakouts = $status = "";
                if($list['pl_prop_type'] == '1'){ $ptype = 'Local';}else{ $ptype = 'Global';}
                if($list['pl_prop_type'] == '1'){ $geography = ucfirst($list['country_name']);}else{ $geography = ucfirst($list['r_name']);}
                if($list['pl_class'] == '1'){ $pclass = "Data"; }elseif($list['pl_class'] == '2'){ $pclass = 'data and Voice'; }else{ $pclass = "-"; }
                if($list['pl_plan_type'] == '1'){ $type = "Traveller Plan"; }elseif($list['pl_plan_type'] == '2'){ $type = 'Long Stay Plan'; }elseif($list['pl_plan_type'] == '3'){ $type = 'Monthly Plan'; }else{ $type = "-"; }
                $data_allow_type = "";
                        if($list['pl_data_allow_type'] == '1'){
                          $data_allow_type = 'MB';
                        }elseif($list['pl_data_allow_type'] == '2'){
                          $data_allow_type = 'GB';
                        }
                $data = $list['pl_data_allowance']." ".$data_allow_type;
                $validity_type = "";
                        if($list['pl_validity_type'] == '1'){
                          $validity_type = 'Days';
                        }elseif($list['pl_validity_type'] == '2'){
                          $validity_type = 'Months';
                        }elseif($list['pl_validity_type'] == '3'){
                          $validity_type = 'Years';
                        } 
                $validity = $list['pl_validity']." ".$validity_type;
                if($list['pl_recharge'] == '1'){ $isRechargable = "Rechargable"; }else{ $isRechargable = 'Not Rechargable'; }
                if($list['pl_policy'] == '1'){ $policy = "Yes"; }else{ $policy = 'No'; } 
                if($list['pl_local_breakouts'] == 'Y'){ $breakouts = "Yes"; }else{ $breakouts = 'No'; } 
                if($list['pl_status'] == '0'){ $status = "Active"; }else{ $status = 'Inactive'; } 
                $activeWorksheet->setCellValue('A'.$sheet_cnt, $sn);
                $activeWorksheet->setCellValue('B'.$sheet_cnt, $ptype);
                $activeWorksheet->setCellValue('C'.$sheet_cnt, $list['pl_product_code']);
                $activeWorksheet->setCellValue('D'.$sheet_cnt, $pclass);
                $activeWorksheet->setCellValue('E'.$sheet_cnt, ucfirst($list['pl_name']));
                $activeWorksheet->setCellValue('F'.$sheet_cnt, ucfirst($list['sp_name']));
                $activeWorksheet->setCellValue('G'.$sheet_cnt, $geography);
                $activeWorksheet->setCellValue('H'.$sheet_cnt, $type);
                $activeWorksheet->setCellValue('I'.$sheet_cnt, $data);
                $activeWorksheet->setCellValue('J'.$sheet_cnt, $validity);
                $activeWorksheet->setCellValue('K'.$sheet_cnt, $isRechargable);
                $activeWorksheet->setCellValue('L'.$sheet_cnt, $policy);
                $activeWorksheet->setCellValue('M'.$sheet_cnt, $list['pl_buying_cost']);
                $activeWorksheet->setCellValue('N'.$sheet_cnt, $list['pl_voice_minutes']);
                $activeWorksheet->setCellValue('O'.$sheet_cnt, $breakouts);
                $activeWorksheet->setCellValue('P'.$sheet_cnt, $list['pl_top_seller']);
                $activeWorksheet->setCellValue('Q'.$sheet_cnt, $list['pl_best_Seller']);
                $activeWorksheet->setCellValue('R'.$sheet_cnt, $list['pl_apn']);
                $activeWorksheet->setCellValue('S'.$sheet_cnt, $list['pl_price_per_gb']);
                $activeWorksheet->setCellValue('T'.$sheet_cnt, $list['pl_price_per_mb']);
                $activeWorksheet->setCellValue('U'.$sheet_cnt, $list['pl_speed']);
                $activeWorksheet->setCellValue('V'.$sheet_cnt, $list['pl_stock_value']);
                $activeWorksheet->setCellValue('W'.$sheet_cnt, $status);
                $sn++;$sheet_cnt++;
            }
        }
        $writer = new Xlsx($spreadsheet);
        $writer->save('php://output');
    }
    
    //supplier
    public function supplier(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'sp_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallsuppliers('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallsuppliers('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-supplier/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/supplier',
            'default_sort'      => 'sp_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/supplier_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_supplier(){
        $data['countries'] = $this->Home_model->countryList();
        $this->load->view('admin/add_supplier',$data);
    }

    public function add_new_supplier(){

        $uploadedImage = "";
        if(!empty($_FILES['sp_cdrapi']['name'])){
                
                $config['upload_path']      = "assets/images/supplier_cdr_api";
                $config['allowed_types']    = "pdf|png|doc|docx|jpg|jpeg";
                $config['encrypt_name']     =  true;
                $config['overwrite']        =  TRUE;
             
                $this->load->library('upload', $config);
                $this->upload->initialize($config);
                if(!$this->upload->do_upload('sp_cdrapi'))
                    {
                        $error  = array('error'  => $this->upload->display_errors());
                        
                    }
                    else
                    {
                        $uploadedImage  = $this->upload->data('file_name');
                        //echo "ok"; print_r($uploadedImage);die;
                    }
        }
        $result = $this->Home_model->add_supplier($uploadedImage);
        echo json_encode($result);
       
    }
    
    public function delete_supplier(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_supplier_byID($id);
        echo json_encode($data);
    }

    public function edit_supplier(){
        $id = $this->uri->segment(2);
        $data['countries'] = $this->Home_model->countryList();
        $data['type'] = 'edit';
        $data['details'] = $this->Home_model->get_supplier_byID($id);
        $this->load->view('admin/add_supplier',$data);
    }

    public function edit_new_supplier(){
        $id = $this->input->post('cid');
        $uploadedImage = "";
        if(!empty($_FILES['sp_cdrapi']['name'])){
                
                $config['upload_path']      = "assets/images/supplier_cdr_api";
                $config['allowed_types']    = "pdf|png|doc|docx|jpg|jpeg";
                $config['encrypt_name']     =  true;
                $config['overwrite']        =  TRUE;
             
                $this->load->library('upload', $config);
                $this->upload->initialize($config);
                if(!$this->upload->do_upload('sp_cdrapi'))
                    {
                        $error  = array('error'  => $this->upload->display_errors());
                        
                    }
                    else
                    {
                        $uploadedImage  = $this->upload->data('file_name');
                        //echo "ok"; print_r($uploadedImage);die;
                    }
        }
        $result = $this->Home_model->edit_supplier($id,$uploadedImage);
        echo json_encode($result);
       
    }

     //operator
    public function operator(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'op_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getalloperators('data',$where_data);
        $data['total_records'] =  $this->Home_model->getalloperators('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-operator/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/operator',
            'default_sort'      => 'op_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/operator_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_operator(){
        $this->load->view('admin/add_operator');
    }

    public function add_new_operator(){

        $result = $this->Home_model->add_operator();
        echo json_encode($result);
       
    }

    public function delete_operator(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_operator_byID($id);
        echo json_encode($data);
    }

    public function get_operator_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['operator'] = $this->Home_model->get_operator_byID();

            parent::s_render('admin/add_operator',$data);
            
        }
    }

    public function edit_operator(){
        $result = $this->Home_model->edit_operator();
        echo json_encode($result);
       
    }

    //Affiliate

    public function affiliate(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'af_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallAffiliate('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallAffiliate('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-affiliate/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/affiliate',
            'default_sort'      => 'af_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/affiliate_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_affiliate(){
        $res = $this->Home_model->add_affiliate();
        echo json_encode($res);
    }

    public function get_affiliate_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['details'] = $this->Home_model->get_affiliate_byID();

            parent::s_render('admin/add_affiliate',$data);
            
        }
    }

    public function delete_affiliate(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_affiliate_byID($id);
        echo json_encode($data);
    }

    //Enquiries
    public function enquiries(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'eq_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getAllenquiries('data',$where_data);
        $data['total_records'] =  $this->Home_model->getAllenquiries('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-enquiries/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/enquiries',
            'default_sort'      => 'eq_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/enquiries_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    //partner

    public function add_partner_enquiry(){
        $resp = $this->Home_model->add_partner_enquiry();
        echo json_encode($resp);
    }

    public function partner_enquiries(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pe_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getAllpartner_enquiries('data',$where_data);
        $data['total_records'] =  $this->Home_model->getAllpartner_enquiries('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-partner-enquiries/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/partner_enquiries',
            'default_sort'      => 'pe_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/partner_enquiries_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function delete_partner_enquiry(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_partner_enquiry_byID($id);
        echo json_encode($data);
    }

    public function partner(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pt_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        $data['plans'] = $this->Home_model->getPlanListByPropertyType();
        $data['data'] = $this->Home_model->getallpartners('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallpartners('count',$where_data);
        //echo '<pre>'; print_r($data);die;
            // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-partner/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/partner',
            'default_sort'      => 'pt_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/partner_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_partner(){
        $id = $this->uri->segment(2);
        $data = array();
        if($id !="" && $id > 0){
            $data['enquiry'] = $this->Home_model->get_partner_enq_byID($id);
        }
        $this->load->view('admin/add_partner',$data);
    }

    public function add_new_partner(){

        $result = $this->Home_model->add_partner();
        echo json_encode($result);
        
    }
    
    public function delete_partner(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_partner_byID($id);
        echo json_encode($data);
    }
    
    public function edit_partner(){
        $id = $this->uri->segment(2);
        $data['type'] = 'edit';
        $data['details'] = $this->Home_model->get_partner_byID($id);
        $this->load->view('admin/add_partner',$data);
    }

    public function edit_new_partner(){
        
        $id = $this->input->post('cid');
        $result = $this->Home_model->edit_partner($id);
        echo json_encode($result);
           
    }

    public function  view_inventory() {
        $result = $this->Home_model->view_inventory();
        echo json_encode($result);
    }

     //coupon
     public function coupon(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'co_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallcoupons('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallcoupons('count',$where_data);
        $data['affiliates'] = $this->Home_model->affiliateList();
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-coupon/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/coupon',
            'default_sort'      => 'co_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/coupon_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_coupon(){
        $data['countries'] = $this->Home_model->countryList();
        $data['regions'] = $this->Home_model->getRegionList();
        $data['affiliates'] = $this->Home_model->affiliateList();
        $this->load->view('admin/add_coupon',$data);
    }

    public function add_new_coupon(){
        $result = $this->Home_model->add_coupon();
        echo json_encode($result);
    }
    
    public function delete_coupon(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_coupon_byID($id);
        echo json_encode($data);
    }

    public function edit_coupon(){
        $id = $this->uri->segment(2);
        $data['affiliates'] = $this->Home_model->affiliateList();
        $data['type'] = 'edit';
        $data['details'] = $this->Home_model->get_coupon_byID($id);
        $this->load->view('admin/add_coupon',$data);
    }

    public function edit_new_coupon(){
        
        $id = $this->input->post('cid');
        $result = $this->Home_model->edit_coupon($id);
        echo json_encode($result);
       
    }

    public function change_status_coupon(){
        $result = $this->Home_model->change_status_coupon();
        echo json_encode($result);
    }

    //complaints
    public function complaint(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'cm_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        
        $data['prod_types'] = $this->Home_model->getproductList();
        $data['data'] = $this->Home_model->getallComplaints('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallComplaints('count',$where_data);
        //echo '<pre>'; print_r($data);die;
            // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-complaint/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/complaint',
            'default_sort'      => 'cm_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/complaint_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_complaint(){
        $res = $this->Home_model->add_complaint();
        echo json_encode($res);
    }

    public function get_complaint_byID(){

        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['prod_types'] = $this->Home_model->getproductList();
            $data['details'] = $this->Home_model->get_complaint_byID();
            parent::s_render('admin/add_complaint',$data);
            
        }
    }

    public function delete_complaint(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_complaint_byID($id);
        echo json_encode($data);
    }

    //sub complaints

    public function sub_complaint(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'sc_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        $data['prod_types'] = $this->Home_model->getproductList();
        $data['complaint_list'] = $this->Home_model->getcomplaintsList();
        $data['data'] = $this->Home_model->getallsub_complaints('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallsub_complaints('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-sub_complaint/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/sub_complaint',
            'default_sort'      => 'sc_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/sub_complaint_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_sub_complaint(){
        $res = $this->Home_model->add_sub_complaint();
        echo json_encode($res);
    }

    public function get_sub_complaint_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['details'] = $this->Home_model->get_sub_complaint_byID();
            $data['prod_types'] = $this->Home_model->getproductList();
            $data['complaint_list'] = $this->Home_model->getcomplaintsList();
            parent::s_render('admin/add_sub_complaint',$data);
            
        }
    }

    public function get_sub_complaints(){
        $res = $this->Home_model->get_sub_complaints();
        echo json_encode($res);
    }
    public function delete_sub_complaint(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_sub_complaint_byID($id);
        echo json_encode($data);
    }

    public function tickets(){ 
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 't_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        
        $data['data'] = $this->Home_model->getalltickets('data',$where_data);
        $data['total_records'] =  $this->Home_model->getalltickets('count',$where_data);
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-tickets/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/tickets',
            'default_sort'      => 't_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/tickets_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function view_ticket(){
        $id = $this->uri->segment(2);
        if($id != ""){
            $data['details'] = $this->Home_model->view_ticket($id);
        }
        $this->load->view('admin/view_ticket',$data);
    }

    public function update_ticket_status(){
        $response = $this->Home_model->update_ticket_status();
        echo json_encode($response);
    }

    //esim devices
    public function esimdevices(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'ed_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        
        $data['data'] = $this->Home_model->getalldevices('data',$where_data);
        $data['total_records'] =  $this->Home_model->getalldevices('count',$where_data);
        //echo '<pre>'; print_r($data);die;
            // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-esimdevices/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/esimdevices',
            'default_sort'      => 'ed_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/device_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_device(){
        $res = $this->Home_model->add_device();
        echo json_encode($res);
    }

    public function get_device_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['details'] = $this->Home_model->get_device_byID();

            parent::s_render('admin/add_esimdevice',$data);
            
        }
    }

    public function delete_device(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_device_byID($id);
        echo json_encode($data);
    }

    //website inventory report
    public function website_inventory_report(){ 
       
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');
       
        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pl_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],  
                  
        ); 
        
        $data['data'] = $this->Home_model->getwebsiteinventoryreport('data',$where_data);
        $data['total_records'] =  $this->Home_model->getwebsiteinventoryreport('count',$where_data);
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-website-inventory-report/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/website_inventory_report',
            'default_sort'      => 'pl_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/web_inventory_report_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

     //website inventory report
     public function signup_report(){ 
       
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'eq_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        
        $data['data'] = $this->Home_model->getAllenquiries('data',$where_data);
        $data['total_records'] =  $this->Home_model->getAllenquiries('count',$where_data);
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-signup-report/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/signup_report',
            'default_sort'      => 'eq_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/signup_report_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    // Sale report
    public function sale_report(){ 
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'o_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        
        $data['data'] = $this->Home_model->getAllorders('data',$where_data);
        $data['total_records'] =  $this->Home_model->getAllorders('count',$where_data);
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-sale-report/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/sale_report',
            'default_sort'      => 'o_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/sale_report_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function export_sale_report(){
        
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        $export_data = $this->Home_model->getAllorders('data',$where_data);
        //echo '<pre>'; print_r($export_data); die;
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="sale-report.xlsx"');
        $spreadsheet = new Spreadsheet();
        $activeWorksheet = $spreadsheet->getActiveSheet();
        $activeWorksheet->setCellValue('A1', 'Srno');
        $activeWorksheet->setCellValue('B1', 'Order ID');
        $activeWorksheet->setCellValue('C1', 'Sale Date');
        $activeWorksheet->setCellValue('D1', 'Plan');
        $activeWorksheet->setCellValue('E1', 'Purchase Source');
        $activeWorksheet->setCellValue('F1', 'Customer Name');
        $activeWorksheet->setCellValue('G1', 'Customer Email');
        $activeWorksheet->setCellValue('H1', 'Geography');
        $activeWorksheet->setCellValue('I1', 'Validity');
        $activeWorksheet->setCellValue('J1', 'Activation Code');
        $activeWorksheet->setCellValue('K1', 'Buying Cost');
        $activeWorksheet->setCellValue('L1', 'Selling Cost');
        if(!empty($export_data) && $export_data!=""){
            $sn = 1; $sheet_cnt = 2;
            foreach($export_data as $list){ 
           
                $activeWorksheet->setCellValue('A'.$sheet_cnt, $sn);
                $activeWorksheet->setCellValue('B'.$sheet_cnt, $list['o_order_id']);
                $activeWorksheet->setCellValue('C'.$sheet_cnt, date('d-m-Y H:i:s',strtotime($list['o_created_on'])));
                $activeWorksheet->setCellValue('D'.$sheet_cnt, $list['o_plan_name']);
                $activeWorksheet->setCellValue('E'.$sheet_cnt, 'ESIMZON');
                $activeWorksheet->setCellValue('F'.$sheet_cnt, $list['o_user_name']);
                $activeWorksheet->setCellValue('G'.$sheet_cnt, $list['o_user_email']);
                $activeWorksheet->setCellValue('H'.$sheet_cnt, $list['o_geography']);
                $activeWorksheet->setCellValue('I'.$sheet_cnt, $list['o_validity']);
                $activeWorksheet->setCellValue('J'.$sheet_cnt, $list['o_activation_code']);
                $activeWorksheet->setCellValue('K'.$sheet_cnt, $list['o_amount']);
                $activeWorksheet->setCellValue('L'.$sheet_cnt, $list['o_total']);
                $sn++;$sheet_cnt++;
            }
        }
        $writer = new Xlsx($spreadsheet);
        $writer->save('php://output');
    }

    //payments
    public function payments(){ 
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pm_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
        
        $data['data'] = $this->Home_model->getAllpayments('data',$where_data);
        $data['total_records'] =  $this->Home_model->getAllpayments('count',$where_data);
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-payments/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/payments',
            'default_sort'      => 'pm_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/payments_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    //network sction code starts here
    public function network(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'nt_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallnetworks('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallnetworks('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-network/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/network',
            'default_sort'      => 'nt_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/network_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_network(){
        $this->load->view('admin/add_network');
    }

    public function add_new_network(){

        $result = $this->Home_model->add_network();
        echo json_encode($result);
       
    }

    public function delete_network(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_network_byID($id);
        echo json_encode($data);
    }

    public function get_network_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['network'] = $this->Home_model->get_network_byID();
            parent::s_render('admin/add_network',$data);
        }
    }

    public function edit_network(){
        $result = $this->Home_model->edit_network();
        echo json_encode($result);
       
    }

    public function kyc_users(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'k_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallkycusers('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallkycusers('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-kyc-user/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/kyc_user',
            'default_sort'      => 'k_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/kyc_user_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function export_kyc_users(){
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        $export_data = $this->Home_model->getallkycusers('data',$where_data);
        //echo '<pre>'; print_r($export_data); die;
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="kyc-users-report.xlsx"');
        $spreadsheet = new Spreadsheet();
        $activeWorksheet = $spreadsheet->getActiveSheet();
        $activeWorksheet->setCellValue('A1', 'Srno');
        $activeWorksheet->setCellValue('B1', 'KYC Type');
        $activeWorksheet->setCellValue('C1', 'Customer Name');
        $activeWorksheet->setCellValue('D1', 'Email');
        $activeWorksheet->setCellValue('E1', 'Plan');
        $activeWorksheet->setCellValue('F1', 'Purchase Status');
        $activeWorksheet->setCellValue('G1', 'Status');
        $activeWorksheet->setCellValue('H1', 'Document Type');
        $activeWorksheet->setCellValue('I1', 'Remarks');
        $activeWorksheet->setCellValue('J1', 'KYC Date');

        if(!empty($export_data) && $export_data!=""){
            $sn = 1; $sheet_cnt = 2;
            foreach($export_data as $list){ $kyc_type = "";
                if($list['k_kyc_type'] == '1'){ $kyc_type = 'Student KYC';}else{ $kyc_type = 'User KYC';}
                $kyc_status = "";
                if($list['k_status'] == 'U'){ $kyc_status = 'Under Verification';}
                else if($list['k_status'] == 'S'){ $kyc_status = 'Completed';}else{
                    $kyc_status = 'Declined';
                }
                $document_type = "";
                if($list['k_document_type'] == '1'){ $document_type = 'Passport';}else{ $document_type = 'Driving License';}
                $activeWorksheet->setCellValue('A'.$sheet_cnt, $sn);
                $activeWorksheet->setCellValue('B'.$sheet_cnt, $kyc_type);
                $activeWorksheet->setCellValue('C'.$sheet_cnt, ucwords($list['u_name']));
                $activeWorksheet->setCellValue('D'.$sheet_cnt, $list['u_email']);
                $activeWorksheet->setCellValue('E'.$sheet_cnt, ucfirst($list['pl_name']));
                $activeWorksheet->setCellValue('F'.$sheet_cnt, $list['k_purchasre_status']);
                $activeWorksheet->setCellValue('G'.$sheet_cnt, $kyc_status);
                $activeWorksheet->setCellValue('H'.$sheet_cnt, $document_type);
                $activeWorksheet->setCellValue('I'.$sheet_cnt, $list['k_remarks']);
                $activeWorksheet->setCellValue('J'.$sheet_cnt, date('d-m-Y',strtotime($list['k_created_date'])));
                $sn++;$sheet_cnt++;
            }
        }
        $writer = new Xlsx($spreadsheet);
        $writer->save('php://output');
    }

    public function kyc_sale(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'ky_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallkycsale('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallkycsale('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-kyc-sale/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/kyc_sale',
            'default_sort'      => 'ky_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/kyc_sale_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config); 
    }

    public function kyc_user_details(){
        if($this->uri->segment(2) != ""){
            $data['data'] = $this->Home_model->get_kyc_user_data_byID($this->uri->segment(2));
        }else{
            $data['data'] = "";
        }
        $this->load->view('admin/kyc_user_details',$data);
    }

    public function kyc_status_update(){
        $result = $this->Home_model->update_kyc_user_status();
        echo json_encode($result);
    }

    public function api_sale(){ 
        $this->load->view('admin/api_sale');
    }

    public function inventory_quick_tool(){ 
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');
        $data['plan']          = $this->get_request_params('plan','');
       
        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'i_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],     
            "plan"         => $data['plan'],      
        ); 
    
        $data['data'] = $this->Home_model->getallinventory('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallinventory('count',$where_data);
        $data['plans'] = $this->Home_model->get_allplans();
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-inventory-quick-tool/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/inventory_quick_tool',
            'default_sort'      => 'i_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/inventory_quick_tool_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_inventory(){
        $data['plans'] = $this->Home_model->getPlanListByPropertyType();
        $id = $this->uri->segment(2);
        if($id != ""){
            $data['details'] = $this->Home_model->getEachInventoryDetails($id);
        }else{
            $data['details'] = "";
        }
        $this->load->view('admin/add_inventory',$data);
    }

    public function add_new_inventory(){
        $response = $this->Home_model->add_new_inventory();
        echo json_encode($response);
    }

    public function change_inventory_stock_status(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->change_inventory_stock_status_byID($id);
        echo json_encode($data);
    }

    public function delete_inventory(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_inventory($id);
        echo json_encode($data);
    }

    public function upload_bulk_inventory(){

        $plan_id = $this->input->post('bulk_plan_name'); 
        $excel_file = $_FILES['bulk_data']['name'];
        $extension = pathinfo($excel_file,PATHINFO_EXTENSION);
        if($extension == 'csv'){
            $reader = new \PhpOffice\PhpSpreadsheet\Reader\Csv();
        }else if($extension == 'xls'){
            $reader = new \PhpOffice\PhpSpreadsheet\Reader\Xls();
        }
        else if($extension == 'xlsx'){
            $reader = new \PhpOffice\PhpSpreadsheet\Reader\Xlsx();
        }else{
            $reader = "";
        }
        if(!empty($reader)){
            $spreadsheet = $reader->load($_FILES['bulk_data']['tmp_name']);
            $sheetdata = $spreadsheet->getActiveSheet()->toArray();
           
        }else{
            echo 'plese select csv/xls/xlsx filetype only!';
        }

        $data = array();
       // echo '<pre>'; print_r($sheetdata); die;
        for($i=1;$i<count($sheetdata);$i++)
        {
            if($sheetdata[$i][0] !=""){
                $data[] = array('i_plan_id'=>$plan_id, 
                            'i_activation_code'=>$sheetdata[$i][0],
                            'i_sim_pin'=>$sheetdata[$i][1],
                            'i_iccid'=>$sheetdata[$i][2],
                            'i_service_id'=>$sheetdata[$i][3],
                            'i_created_date'=>date('Y-m-d H:i:s')
                        );
            }
            
        }  
        $table = 'inventory';
        $response = $this->Home_model->insert_batch($data,$table);    
        echo json_encode($response);
        
    }

    public function get_inventory_remarks(){
        $response = $this->Home_model->get_inventory_remarks();
        echo json_encode($response);
    }

    public function update_inventory_remarks(){
        $response = $this->Home_model->update_inventory_remarks();
        echo json_encode($response);
    }

    public function get_selling_price(){
        $response = $this->Home_model->get_selling_price();
        echo json_encode($response);
    }

    public function update_inventory_selling_price(){
        $response = $this->Home_model->update_inventory_selling_price();
        echo json_encode($response);
    }

    public function export_inventory_data(){
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        $export_data = $this->Home_model->getallinventory('data',$where_data);
        //echo '<pre>'; print_r($export_data); die;
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="inventory-report.xlsx"');
        $spreadsheet = new Spreadsheet();
        $activeWorksheet = $spreadsheet->getActiveSheet();
        $activeWorksheet->setCellValue('A1', 'Srno');
        $activeWorksheet->setCellValue('B1', 'Supplier');
        $activeWorksheet->setCellValue('C1', 'Geography');
        $activeWorksheet->setCellValue('D1', 'PIN');
        $activeWorksheet->setCellValue('E1', 'LPA');
        $activeWorksheet->setCellValue('F1', 'ICCID');
        $activeWorksheet->setCellValue('G1', 'Buying Cost');
        $activeWorksheet->setCellValue('H1', 'Selling Cost');
        $activeWorksheet->setCellValue('I1', 'Plan Name');
        $activeWorksheet->setCellValue('J1', 'Start Date');
        $activeWorksheet->setCellValue('K1', 'End Date');
        $activeWorksheet->setCellValue('L1', 'Status');

        if(!empty($export_data) && $export_data!=""){
            $sn = 1; $sheet_cnt = 2;
            foreach($export_data as $list){ $geography = "";
                if($list['pl_prop_type'] == '1'){ $geography = ucfirst($list['country_name']);}else{ $geography = ucfirst($list['r_name']);}
                $activeWorksheet->setCellValue('A'.$sheet_cnt, $sn);
                $activeWorksheet->setCellValue('B'.$sheet_cnt, ucfirst($list['sp_name']));
                $activeWorksheet->setCellValue('C'.$sheet_cnt, $geography);
                $activeWorksheet->setCellValue('D'.$sheet_cnt, $list['i_sim_pin']);
                $activeWorksheet->setCellValue('E'.$sheet_cnt, $list['i_activation_code']);
                $activeWorksheet->setCellValue('F'.$sheet_cnt, $list['i_iccid']);
                $activeWorksheet->setCellValue('G'.$sheet_cnt, $list['pl_buying_cost']);
                $activeWorksheet->setCellValue('H'.$sheet_cnt, $list['i_selling_price']);
                $activeWorksheet->setCellValue('I'.$sheet_cnt, ucfirst($list['pl_name']));
                $activeWorksheet->setCellValue('J'.$sheet_cnt, date('d-m-Y',strtotime($list['i_created_date'])));
                $activeWorksheet->setCellValue('K'.$sheet_cnt, date('d-m-Y',strtotime($list['i_created_date'])));
                $activeWorksheet->setCellValue('L'.$sheet_cnt, $list['i_sim_status']);
                $sn++;$sheet_cnt++;
            }
        }
        $writer = new Xlsx($spreadsheet);
        $writer->save('php://output');
    }

    public function getPlanListByPropertyType(){
        $response = $this->Home_model->getPlanListByPropertyType();
        echo json_encode($response);
    }

    // ---- Billing section 
    
    public function create_offline_customer(){
        $this->load->view('admin/create_offline_customer');
    }

    public function add_new_offline_customer(){
        $response = $this->Home_model->add_new_offline_customer();
        echo json_encode($response);
    }

    public function create_offline_plan(){
        $this->load->view('admin/create_offline_plan');
    }

    public function offline_plan(){
        $data['suppliers'] = $this->Home_model->supplierList();
        $data['customers'] = $this->Home_model->getOfflineCustomers();
        $this->load->view('admin/offline_plan',$data);
    }

    public function get_offline_plan_by_geography(){
        $response = $this->Home_model->get_offline_plan_by_geography();
        echo json_encode($response);
    }

    public function get_offline_plan_byID(){
        $response = $this->Home_model->get_offline_plan_byID();
        echo json_encode($response);
    }

    public function add_offline_plan(){
        $response = $this->Home_model->add_offline_plan();
        echo json_encode($response);
    }

    public function offline_sale_report(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');
        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'of_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],  
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']
        ); 
    
        $data['data'] = $this->Home_model->getallofflinesalereport('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallofflinesalereport('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-offline-sale-report/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/offline_sale_report',
            'default_sort'      => 'of_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/offline_sale_report_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
        
    }

    public function export_offline_sale_report(){
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        $export_data = $this->Home_model->getallofflinesalereport('data',$where_data);
        //echo '<pre>'; print_r($export_data); die;
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="offline-sale-report.xlsx"');
        $spreadsheet = new Spreadsheet();
        $activeWorksheet = $spreadsheet->getActiveSheet();
        $activeWorksheet->setCellValue('A1', 'Srno');
        $activeWorksheet->setCellValue('B1', 'Order ID');
        $activeWorksheet->setCellValue('C1', 'Sale Date');
        $activeWorksheet->setCellValue('D1', 'Plan');
        $activeWorksheet->setCellValue('E1', 'Purchase Source');
        $activeWorksheet->setCellValue('F1', 'Customer Name');
        $activeWorksheet->setCellValue('G1', 'Customer Email');
        $activeWorksheet->setCellValue('H1', 'Geography');
        $activeWorksheet->setCellValue('I1', 'Validity');
        $activeWorksheet->setCellValue('J1', 'Activation Code');
        $activeWorksheet->setCellValue('K1', 'Buying Cost');
        $activeWorksheet->setCellValue('L1', 'Selling Cost');
        if(!empty($export_data) && $export_data!=""){
            $sn = 1; $sheet_cnt = 2;
            foreach($export_data as $list){ 
           
                $activeWorksheet->setCellValue('A'.$sheet_cnt, $sn);
                $activeWorksheet->setCellValue('B'.$sheet_cnt, $list['of_order_id']);
                $activeWorksheet->setCellValue('C'.$sheet_cnt, date('d-m-Y H:i:s',strtotime($list['of_created_on'])));
                $activeWorksheet->setCellValue('D'.$sheet_cnt, $list['of_plan_name']);
                $activeWorksheet->setCellValue('E'.$sheet_cnt, 'ESIMZON');
                $activeWorksheet->setCellValue('F'.$sheet_cnt, $list['of_user_name']);
                $activeWorksheet->setCellValue('G'.$sheet_cnt, $list['of_user_email']);
                $activeWorksheet->setCellValue('H'.$sheet_cnt, $list['of_geography']);
                $activeWorksheet->setCellValue('I'.$sheet_cnt, $list['of_validity']);
                $activeWorksheet->setCellValue('J'.$sheet_cnt, $list['of_activation_code']);
                $activeWorksheet->setCellValue('K'.$sheet_cnt, $list['of_amount']);
                $activeWorksheet->setCellValue('L'.$sheet_cnt, $list['of_total']);
                $sn++;$sheet_cnt++;
            }
        }
        $writer = new Xlsx($spreadsheet);
        $writer->save('php://output');
    }

    public function data_sync(){
        $data['countries'] = $this->Home_model->countryList();
        $data['regions'] = $this->Home_model->getRegionList();
        $this->load->view('admin/data_sync',$data);
    }

    public function get_plan_by_country(){
        $response = $this->Home_model->get_plan_by_country();
        echo json_encode($response);
    } 

    public function update_plan_by_country(){
        $response = $this->Home_model->update_plan_by_country();
        echo json_encode($response);
    }

    public function update_all_plans_by_country(){
        $response = $this->Home_model->update_all_plans_by_country();
        echo json_encode($response);
    }

    public function get_plan_by_region(){
        $response = $this->Home_model->get_plan_by_region();
        echo json_encode($response);
    } 

    public function update_plan_by_region(){
        $response = $this->Home_model->update_plan_by_region();
        echo json_encode($response);
    }

    public function update_all_plans_by_region(){
        $response = $this->Home_model->update_all_plans_by_region();
        echo json_encode($response);
    }

    public function order_set(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');
        $data['country']         = $this->get_request_params('country','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pl_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],  
            "country"        => $data['country'],        
        ); 
    
        $data['data'] = $this->Home_model->getallplan_orders('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallplan_orders('count',$where_data);
        $data['countries'] = $this->Home_model->countryList();
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-order-set/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/order_set',
            'default_sort'      => 'pl_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/order_set_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function get_order_data(){
        $id = $this->input->post('new_id');
        $response = $this->Home_model->get_order_data($id);
        echo json_encode($response);
    }

    public function update_order_data(){
        $response = $this->Home_model->update_order_data();
        echo json_encode($response);
    }

    public function rechargable_topup(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'tp_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallrechargable_topups('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallrechargable_topups('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-rechargable-topup/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/rechargable_topup',
            'default_sort'      => 'tp_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/rechargable_topup_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function create_topup(){
        
        $data['suppliers'] = $this->Home_model->supplierList();
        $this->load->view('admin/crearte_topup',$data);
    }

    public function create_new_topup(){
        $result = $this->Home_model->create_new_topup();
        echo json_encode($result);
    }

    public function edit_topup(){
        $id = $this->uri->segment(2);
        $data['type'] = 'edit';
        $data['topup_details'] = $this->Home_model->get_topup_byID($id);
        $data['plan_details'] = $this->Home_model->get_plan_by_supplier($id);
        $this->load->view('admin/crearte_topup',$data);
    }

    public function edit_topup_by_id(){
        $result = $this->Home_model->create_new_topup();
        echo json_encode($result);
       
    }

    public function delete_topup(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_topup_byID($id);
        echo json_encode($data);
    }

    public function change_topup_status(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->change_topup_status_byID($id);
        echo json_encode($data);
    }

    public function get_plancost_by_plan(){
        $id = $this->input->post('id');
        $data = $this->Home_model->get_plancost_by_plan($id);
        echo json_encode($data);
    }

    public function get_supplier_country_cost_by_plan(){
        $id = $this->input->post('id');
        $data = $this->Home_model->get_supplier_country_cost_by_plan($id);
        echo json_encode($data);
    }

    public function get_plan_by_supplier(){
        $id = $this->input->post('id');
        $data = $this->Home_model->get_plan_by_supplier($id);
        echo json_encode($data);
    }

    //faq

    public function faq(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'fq_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getallfaq('data',$where_data);
        $data['total_records'] =  $this->Home_model->getallfaq('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-faq/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/faq',
            'default_sort'      => 'fq_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/faq_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_faq(){
        $res = $this->Home_model->add_faq();
        echo json_encode($res);
    }

    public function get_faq_byID(){
        if($this->input->post('type')=='edit'){
            $data['type'] = $this->input->post('type');
            $data['details'] = $this->Home_model->get_faq_byID();

            parent::s_render('admin/add_faq',$data);
            
        }
    }

    public function delete_faq(){
        $id = $this->input->post('new_id');
        $data = $this->Home_model->delete_faq_byID($id);
        echo json_encode($data);
    }
    
    public function termscondition(){
        $data['details'] = $this->Home_model->get_terms_condition();
        $this->load->view('admin/termscondition',$data);
    }
    public function save_terms_condition(){
        $data = $this->Home_model->save_terms_condition();
        echo json_encode($data);
    }

    public function privacypolicy(){
        $data['details'] = $this->Home_model->get_privacypolicy();
        $this->load->view('admin/privacypolicy',$data);
    }

    public function save_privacypolicy(){
        $data = $this->Home_model->save_privacypolicy();
        echo json_encode($data);
    }

    public function refundpolicy(){
        $data['details'] = $this->Home_model->get_refundpolicy();
        $this->load->view('admin/refundpolicy',$data);
    }

    public function save_refundpolicy(){
        $data = $this->Home_model->save_refundpolicy();
        echo json_encode($data);
    }

    public function index_banner(){
        $data['details'] = $this->Home_model->get_index_banner();
        $this->load->view('admin/indexbanner',$data);
    }

    public function save_index_banner(){
        $banner_image = "";
        if(!empty($_FILES['index_banner']['name'])){
                
            $config['upload_path']      = "assets/images/banner";
            $config['allowed_types']    = "png|jpg|jpeg|gif|webp";
            $config['encrypt_name']     =  TRUE;
            $config['overwrite']        =  TRUE;
         
            $this->load->library('upload', $config);
            $this->upload->initialize($config);
            if(!$this->upload->do_upload('index_banner'))
                {
                    $error  = array('error'  => $this->upload->display_errors());
                    
                }
                else
                {
                    $banner_image  = $this->upload->data('file_name');
                    //echo "ok"; print_r($uploadedImage);die;
                }
        }
        $data = $this->Home_model->save_index_banner($banner_image);
        echo json_encode($data);
    }

    public function add_contact(){
        $resp = $this->Home_model->add_contact();
        echo json_encode($resp);
    }

    public function getInventoryListByPlan(){
        $resp = $this->Home_model->getInventoryListByPlan();
        echo json_encode($resp);
    }

    public function send_code_with_partner(){
        $resp = $this->Home_model->send_code_with_partner();
        echo json_encode($resp);
    }

    public function banner_offers(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'pl_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],          
        ); 
    
        $data['data'] = $this->Home_model->getalloffers('data',$where_data);
        $data['total_records'] =  $this->Home_model->getalloffers('count',$where_data);
        //echo '<pre>'; print_r($data);die;
         // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-offers/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/offers',
            'default_sort'      => 'pl_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/offers_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function add_offer(){
        $data['plans'] = $this->Home_model->getPlanListByPropertyType();
        $id = $this->uri->segment(2);
        if($id != ""){
            $data['details'] = $this->Home_model->getOfferDetails($id);
        }else{
            $data['details'] = "";
        }
        
        $this->load->view('admin/add_offer',$data);
    }

    public function add_offer_data(){
        $resp = $this->Home_model->add_offer();
        echo json_encode($resp);
    }
    public function delete_offer(){
        $resp = $this->Home_model->delete_offer();
        echo json_encode($resp);
    }

    public function orders(){
        $data["per_page_option"] = $this->per_page_option;
        $data["per_page"]        = $this->get_page_vars('per_page', 20);
        $data["page"]            = $this->get_page_vars('page','',$this->page_segment);        
        $data['search']          = $this->get_request_params('search','');
        $data['start_date']      = $this->get_request_params('start_date','');
        $data['end_date']        = $this->get_request_params('end_date','');

        $where_data =   array(
            "sort_by"        => $this->get_page_vars('sort_by', 'o_id'),
            "sort_direction" => $this->get_page_vars('sort_direction', 'DESC'),
            "per_page"       => $data["per_page"],
            "page"           => $this->get_page_vars('page', '', $this->page_segment),
            "search"         => $data['search'],    
            "start_date"     => $data['start_date'], 
            "end_date"       => $data['end_date']      
        ); 
        
        $data['data'] = $this->Home_model->getAllorders('data',$where_data);
        $data['total_records'] =  $this->Home_model->getAllorders('count',$where_data);
        //echo '<pre>'; print_r($data);die;
        // Set page configs
        $page_config = array(
            'paging_url'        => 'admin-orders/',
            'page_segment'      => $this->page_segment,
            'per_page'          => $this->get_page_vars('per_page', 20),
            'total_records'     => $data['total_records'],
            'list'              => 'admin/orders',
            'default_sort'      => 'o_id',
            'default_direction' => 'desc',
            'list_ajax'         => 'admin/orders_ajax',
            'data'              => $data
        );
        $this->set_pagination($page_config);
    }

    public function send_order_mail(){
       
        $response = $this->Home_model->send_order_mail();
        redirect('admin-orders');
        //echo json_encode($response);
    }

    
/*----------------------pagination code start------------------------*/
    public function get_pagination($base_url = '', $suffix = '', $total_rows = 0, $uri_segment = 3, $per_page = 0, $num_links = 2,$page_query_string=FALSE)
    {
        $config['uri_segment']        = $uri_segment;
        
        $config['base_url']           = $base_url;
        
        $config['suffix']             = $suffix;
        
        $config['per_page']           = $per_page;
        
        $config['num_links']          = $num_links;
        
        $config['total_rows']         = $total_rows;
        
        $config['page_query_string']  = $page_query_string;

        if($page_query_string)
        $config['query_string_segment']  = "page";

        
        $config['anchor_class']       = 'paginate_button';
        
        $config['first_link_class']   = 'first paginate_button';
        
        $config['prev_link_class']    = 'previous paginate_button';
        
        $config['next_link_class']    = 'next paginate_button';
        
        $config['last_link_class']    = 'last paginate_button';
        
        $config['active_link_class']  = 'paginate_active paginate_button';
        
        $config['disable_link_class'] = 'paginate_button paginate_button_disabled disabled';
        
        $config['first_tag_open']     = '<li>';
        
        $config['first_tag_close']    = '</li>';
        
        $config['num_tag_open']       = '<li>';
        
        $config['num_tag_close']      = '</li>';
        
        $config['next_tag_open']      = '<li>';
        
        $config['next_tag_close']     = '</li>';
        
        $config['prev_tag_open']      = '<li>';
        
        $config['prev_tag_close']     = '</li>';
        
        $config['last_tag_open']      = '<li>';
        
        $config['last_tag_close']     = '</li>';
        
        $config['cur_tag_open']       = '<li class="active">';
        
        $config['cur_tag_close']      = '</li>';
        
        $config['full_tag_open']      = '<ul class="pagination">';
        
        $config['full_tag_close']     = '</ul>';


        $this->load->library('Pagination_Custom');
        
        $this->pagination_custom->initialize($config);
        
        return $this->pagination_custom->create_links();
    }
/*----------------------pagination code end------------------------*/

}
?>