<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Paypal {

    private $clientId;
    private $clientSecret;
    private $sandboxUrl;
    private $accessToken;

    public function __construct() {
        //$this->clientId = 'AY2gYg3sVjrvbu21ar_az3G910yzcRA4k3oQKrCkBB-JCyWjLFPOv5oIefucI_LSKTkZ5fpDtrIAd_Sm';  // Replace with your Client ID
        //$this->clientSecret = 'EHM6pTU-bzvS6cs0dbg4XKjIZXs4FNkNXO-by3eAlC6ib9-jJeE0Wewp6aB-YMPk4DqCERo1x6cisCq0';  // Replace with your Client Secret
        $this->clientId = 'AdWlWp_-URKh-8fb-bikLOhLlDK6oG2n-gWG2Eo-mfnzV-74vkeVJ5z4WIO0a_24B5DEODiO-ERVl88t';  // Replace with your Client ID
        $this->clientSecret = 'EEWsrVGoRaQ3YcSL02jaoRBELSq25UXVLfS36SACW7vzVa2rg2bQfcbX_hihP6QIU0hHVsUkm6rRzORg';  // Replace with your Client Secret
        $this->sandboxUrl = 'https://api-m.sandbox.paypal.com';  // Change to live URL in production
    }

    private function getAccessToken() {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->sandboxUrl . "/v1/oauth2/token");
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_USERPWD, $this->clientId.":".$this->clientSecret);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ["Content-Type: application/x-www-form-urlencoded"]);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "grant_type=client_credentials");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_VERBOSE, true);

        $response = curl_exec($ch);
        if (curl_errno($ch)) {
            throw new Exception(curl_error($ch));
        }

        $data = json_decode($response, true);
        $this->accessToken = $data['access_token'];
        curl_close($ch);
    }

    public function createPayment($amount, $orderID, $currency = 'USD') {
        $this->getAccessToken();  // Get access token before making payment

        $paymentData = [
            'intent' => 'sale',
            'redirect_urls' => [
                'return_url' => base_url('pay-success'),  // Change as needed
                'cancel_url' => base_url('pay-cancel'),   // Change as needed
            ],
            'payer' => [
                'payment_method' => 'paypal'
            ],
            'transactions' => [[
                'amount' => [
                    'total' => $amount,
                    'currency' => $currency
                ],
                'description' => 'Payment Description'
            ]]
        ];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->sandboxUrl . "/v1/payments/payment");
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            "Content-Type: application/json",
            "Authorization: Bearer $this->accessToken"
        ]);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($paymentData));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $response = curl_exec($ch);
        if (curl_errno($ch)) {
            throw new Exception(curl_error($ch));
        }

        $data = json_decode($response, true);
        curl_close($ch);

        return $data;
    }

    public function getPaymentDetails($paymentId) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://api-m.sandbox.paypal.com/v1/payments/payment/$paymentId");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            "Authorization: Bearer {$this->accessToken}",
            "Content-Type: application/json"
        ]);
        
        $response = curl_exec($ch);
        curl_close($ch);
    
        return json_decode($response, true);
    }
    
}
?>
