<?php
class Home_model extends CI_Model{

	public function getallregions($type,$where_data)
	{ 
		$table = "regions";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('r_id');		
		}
		$this->db->where('r_deleted_status','0');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->or_like('r_name', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('r_id', 'r_name', 'r_index_page')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('r_id','desc');
			}
		}

		$this->db->group_by('r_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function get_region_byID(){
		$table = "regions";
		$id = $this->input->post('id');
		$res = $this->db->where('r_deleted_status','0')->where('r_id',$id)->get($table);
		return $res->row();
	}

	public function add_region($banner_image){
		$table = "regions";
		if($banner_image !=""){
			$banner = $banner_image;
		}else if($this->input->post('prev_banner') != ""){
			$banner = $this->input->post('prev_banner');
		}else{
			$banner = "";
		}
		$data = array('r_name' 		 => $this->input->post('r_name'),
					  'r_banner' 	 =>$banner,
					  'r_index_page' => $this->input->post('r_index_page'),
					  'r_color1' => $this->input->post('r_color1'),
					  'r_color2' => $this->input->post('r_color2')
					);
		if($this->input->post('id') !=""){
			$this->db->where('r_id',$this->input->post('id'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function delete_region_byID($id){
        $table = "regions";
		$data = array('r_deleted_status'=>'1');
		$this->db->where('r_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function getRegionList(){
		$table = "regions";
		$rest = $this->db->where('r_deleted_status','0')->order_by('r_name','asc')->get($table);
		return $rest->result();
	}
	
    public function getallCountries($type,$where_data)
	{ 
		$table = "country";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('country_id');		
		}
		$this->db->where('country_status','0');
		$this->db->from($table);		
		$this->db->join('regions','r_id = country_region');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('country_name', addslashes($where_data['search']));
			$this->db->or_like('country_region', addslashes($where_data['search']));
			$this->db->or_like('country_code', addslashes($where_data['search']));
			$this->db->or_like('country_index_page', addslashes($where_data['search']));					
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('country_id', 'country_name','country_region','country_code','country_index_page','country_status')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('country_id','desc');
			}
		}

		$this->db->group_by('country_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

    public function check_country($id){
        $table = "country";
		$cid = $this->input->post('cid'); 
		if($cid!=""){
			$this->db->where('country_id!=',$cid);
		}
		$this->db->where('country_name',$id);
		$this->db->where('country_status','0');
		$res = $this->db->get($table);
		if($res->num_rows()>0){
			return false;
		}
		else{
			return true;
		}
    }

    public function add_country($uploadedImage){
        $table = "country";
		
		if($uploadedImage !=""){
			$logo = $uploadedImage;
		}else{
			$logo = "";
		}
		if($this->input->post('cid')!=""){
			$img = $this->db->where('country_id',$this->input->post('cid'))->get($table)->row();
			if($logo ==""){
				$logo = $img->country_logo;
			}
		}
		$color1 = $color2 = "";
		if($this->input->post('country_color1') != ""){
			$color1 = $this->input->post('country_color1');
		}
		if($this->input->post('country_color2') != ""){
			$color2 = $this->input->post('country_color2');
		}
		$data = array('country_name'=>$this->input->post('country_name'),
						'country_region'=>$this->input->post('country_region'),
						'country_code'=>$this->input->post('country_code'),
						'country_index_page'=>$this->input->post('country_index_page'),
						'country_color1'=>$color1,
						'country_color2'=>$color2,
						'country_logo' => $logo);
		if($this->input->post('cid')!=""){
			
			$this->db->where('country_id',$this->input->post('cid'));
			$res = $this->db->update($table,$data);
			
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
    }

    public function get_country_byID(){
        $table = "country";
		$this->db->where('country_id',$this->input->post('id'));
		$res = $this->db->get($table);
		return $res->row();
    }

    public function delete_country_byID($id){
        $table = "country";
		$data = array('country_status'=>'1');
		$this->db->where('country_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function countryList(){
		$result = $this->db->select('country_name,country_id,country_logo')
						   ->where('country_status','0')
						   ->order_by('country_id','desc')
						   ->get('country');
		return $result->result();
	}

	public function update_plan_by_country(){
		$data = array('pl_sync' => 'Y');
		$this->db->where('pl_id',$this->input->post('id'));
		$res = $this->db->update('plans',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function update_all_plans_by_region(){
		$data = array('pl_sync' => 'Y');
		$this->db->where('pl_region',$this->input->post('id'));
		$res = $this->db->update('plans',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function update_plan_by_region(){
		$data = array('pl_sync' => 'Y');
		$this->db->where('pl_id',$this->input->post('id'));
		$res = $this->db->update('plans',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function update_all_plans_by_country(){
		$data = array('pl_sync' => 'Y');
		$this->db->where('pl_country',$this->input->post('id'));
		$res = $this->db->update('plans',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_plan_by_country(){
		$qry = $this->db->select('pl_id, pl_name')->where('pl_country',$this->input->post('id'))->get('plans');
		return $qry->result();
	}

	public function get_plan_by_region(){
		$qry = $this->db->select('pl_id, pl_name')->where('pl_region',$this->input->post('id'))->get('plans');
		return $qry->result();
	}

	public function get_offline_plan_by_geography(){
		$this->db->select('pl_id, pl_name');
		$this->db->where('pl_delete_status','0');
		
		if($this->input->post('geo_type' == '2')){
			$this->db->where('pl_region',$this->input->post('id'));
		}else {
			$this->db->where('pl_country',$this->input->post('id'));
		}

		$this->db->where('pl_form_type','2');
		$this->db->or_where('pl_form_type','3');
		$qry = $this->db->get('plans');
		return $qry->result();
	}

	// public function add_plan(){ 
	// 	date_default_timezone_set('Asia/Kolkata');
	// 	if($this->input->post('pl_activation_date') != ""){
	// 		$activation_date =   date('Y-m-d',strtotime($this->input->post('pl_activation_date')));
	// 	  }else{
	// 		$activation_date =  date('Y-m-d');
	// 	  }
	// 	$plan_class = 1;
	// 	if($this->input->post('p_class') != ""){
	// 		$plan_class = $this->input->post('p_class');
	// 	}
	// 	$data = array(  'pl_prop_type' 					=> $this->input->post('p_type'),
	// 					'pl_local_breakouts' 			=> $this->input->post('p_local_breakouts'),
	// 					'pl_class' 						=> $plan_class,
	// 					'pl_voice_minutes' 				=> $this->input->post('p_voice_minutes'),
	// 					'pl_name' 						=> $this->input->post('p_name'),
	// 					'pl_source' 					=> $this->input->post('p_source'),
	// 					'pl_guidelines' 				=> $this->input->post('p_guidelines'),
	// 					'pl_plan_type' 					=> $this->input->post('p_plan_type'),
	// 					'pl_plus_monthly' 				=> $this->input->post('p_plus_monthly'),
	// 					'pl_operator_type' 				=> $this->input->post('p_operator_type'),
	// 					'pl_supplier' 					=> $this->input->post('p_supplier'),
	// 					'pl_price_per_gb' 				=> $this->input->post('p_price_per_gb'),
	// 					'pl_price_per_mb' 				=> $this->input->post('p_price_per_mb'),
	// 					'pl_product_code' 				=> $this->input->post('p_product_code'),
	// 					'pl_capacity_info' 				=> $this->input->post('p_capacity_info'),
	// 					'pl_validity_type' 				=> $this->input->post('p_validity_type'),
	// 					'pl_validity' 					=> $this->input->post('p_validity'),
	// 					'pl_data_allowance' 			=> $this->input->post('p_data_allowance'),
	// 					'pl_data_allow_type' 			=> $this->input->post('p_data_allow_type'),
	// 					'pl_data_allow_validity_type' 	=> $this->input->post('p_data_allow_validity_type'),
	// 					'pl_stock_value'				=> $this->input->post('p_stock_value'),
	// 					'pl_min_cart_value'				=> $this->input->post('p_min_cart_value'),
	// 					'pl_max_cart_value'				=> $this->input->post('p_max_cart_value'),
	// 					'pl_buying_cost'				=> $this->input->post('p_buying_cost'),
	// 					'pl_buying_cost_currency'		=> ($this->input->post('p_buying_cost_currency'))!= NULL ? $this->input->post('p_buying_cost_currency') : "",
	// 					'pl_policy'						=> $this->input->post('p_policy'),
	// 					'pl_recharge'					=> $this->input->post('p_recharge'),
	// 					'pl_country'					=> $this->input->post('p_country'),
	// 					'pl_region'						=> $this->input->post('p_region'),
	// 					'pl_top_seller'					=> $this->input->post('p_top_seller'),
	// 					'pl_best_Seller'				=> $this->input->post('p_best_seller'),
	// 					'pl_best_value'					=> $this->input->post('p_best_value'),
	// 					'pl_min_quantity'				=> $this->input->post('p_min_quantity'),
	// 					'pl_max_quantity'				=> $this->input->post('p_max_quantity'),
	// 					'pl_mcc'						=> $this->input->post('p_mcc'),
	// 					'pl_mnc'						=> $this->input->post('p_mnc'),
	// 					'pl_plan_conditions'			=> $this->input->post('p_condition'),
	// 					'pl_features'					=> $this->input->post('p_features'),
	// 					'pl_apn'						=> $this->input->post('p_apn'),
	// 					'pl_speed'						=> $this->input->post('p_throttle_speed'),
	// 					'pl_remarks'					=> $this->input->post('p_remarks'),
	// 					'pl_info'						=> $this->input->post('p_info'),
	// 					'pl_form_type'					=> $this->input->post('p_form_type'),
	// 					'pl_kyc_status'					=> $this->input->post('p_kyc_status'),
	// 					'pl_need_activation_date'		=> $this->input->post('pl_need_activation_date'),
	// 					'pl_activation_date'			=> $activation_date,
	// 					'pl_created_on'					=> date('Y-m-d h:i:s')
	//     			 );
	// 	if($this->input->post('cid') !=""){
	// 		$this->db->where('pl_id',$this->input->post('cid'));
	// 		$result = $this->db->update('plans',$data);
	// 	}else{
	// 		$result = $this->db->insert('plans',$data);
	// 	}
	// 	if($result){
	// 		return true;
	// 	}else{
	// 		return false;
	// 	}
	// }

	public function add_plan(){ 
		date_default_timezone_set('Asia/Kolkata');
		if($this->input->post('pl_activation_date') != ""){
			$activation_date =   date('Y-m-d',strtotime($this->input->post('pl_activation_date')));
		  }else{
			$activation_date =  date('Y-m-d');
		  }
		$plan_class = 1;
		if($this->input->post('p_class') != ""){
			$plan_class = $this->input->post('p_class');
		}
		$data = array(  'pl_prop_type' 					=> $this->input->post('p_type'),
						'pl_local_breakouts' 			=> $this->input->post('p_local_breakouts'),
						'pl_class' 						=> $plan_class,
						'pl_voice_minutes' 				=> $this->input->post('p_voice_minutes'),
						'pl_name' 						=> $this->input->post('p_name'),
						'pl_source' 					=> $this->input->post('p_source'),
						'pl_plan_type' 					=> $this->input->post('p_plan_type'),
						'pl_plus_monthly' 				=> $this->input->post('p_plus_monthly'),
						'pl_operator_type' 				=> $this->input->post('p_operator_type'),
						'pl_supplier' 					=> $this->input->post('p_supplier'),
						'pl_price_per_gb' 				=> $this->input->post('p_price_per_gb'),
						'pl_price_per_mb' 				=> $this->input->post('p_price_per_mb'),
						'pl_product_code' 				=> $this->input->post('p_product_code'),
						'pl_validity_type' 				=> $this->input->post('p_validity_type'),
						'pl_validity' 					=> $this->input->post('p_validity'),
						'pl_data_allowance' 			=> $this->input->post('p_data_allowance'),
						'pl_data_allow_type' 			=> $this->input->post('p_data_allow_type'),
						'pl_data_allow_validity_type' 	=> $this->input->post('p_data_allow_validity_type'),
						'pl_stock_value'				=> $this->input->post('p_stock_value'),
						'pl_buying_cost'				=> $this->input->post('p_buying_cost'),
						'pl_buying_cost_currency'		=> ($this->input->post('p_buying_cost_currency'))!= NULL ? $this->input->post('p_buying_cost_currency') : "",
						'pl_country'					=> $this->input->post('p_country'),
						'pl_region'						=> $this->input->post('p_region'),
						'pl_top_seller'					=> $this->input->post('p_top_seller'),
						'pl_best_Seller'				=> $this->input->post('p_best_seller'),
						'pl_best_value'					=> $this->input->post('p_best_value'),
						'pl_apn'						=> $this->input->post('p_apn'),
						'pl_remarks'					=> $this->input->post('p_remarks'),
						'pl_info'						=> $this->input->post('p_info'),
						'pl_form_type'					=> $this->input->post('p_form_type'),
						'pl_kyc_status'					=> $this->input->post('p_kyc_status'),
						'pl_need_activation_date'		=> $this->input->post('pl_need_activation_date'),
						'pl_activation_date'			=> $activation_date,
						'pl_created_on'					=> date('Y-m-d h:i:s')
	    			 );
		if($this->input->post('cid') !=""){
			$this->db->where('pl_id',$this->input->post('cid'));
			$result = $this->db->update('plans',$data);
		}else{
			$result = $this->db->insert('plans',$data);
		}
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getallplans($type,$where_data){
		$table = "plans";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('pl_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('pl_delete_status','0');
		$this->db->from($table);		
		$this->db->join('country','country_id=pl_country','left');
		$this->db->join('regions','r_id=pl_region','left');
		$this->db->join('suppliers','sp_id=pl_supplier','left');
		//$this->db->join('guidelines','gd_id=pl_guidelines','left');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('pl_name', addslashes($where_data['search']));
			$this->db->or_like('country_name', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pl_id','pl_name','country_name','pl_status')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('pl_id','desc');
			}
		}

		$this->db->group_by('pl_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function delete_plan_byID($id){
		$table = "plans";
		$data = array('pl_delete_status'=>'1');
		$this->db->where('pl_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function change_plan_status_byID($id){
		$table = "plans";
		$qry = $this->db->select('pl_status')->where('pl_id',$id)->get($table)->row();
		$prev_status = $qry->pl_status;
		$new_status = "0";
		if($prev_status == '0'){
			$new_status = "1";
		}else if($prev_status == '1'){
			$new_status = "0";
		}
		$data = array('pl_status'=> $new_status);
		$this->db->where('pl_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	 public function get_allplans(){
		$qry = $this->db->select('pl_id, pl_name')->where('pl_delete_status','0')->get('plans');
		return $qry->result();
	}

	public function get_plan_byID($id){
		$result = $this->db->where('pl_id',$id)->get('plans')->row();
		return $result;
	}

	public function getPlanListByPropertyType(){
		$id = '1';
		if($this->input->post('id') !=""){
			$id = $this->input->post('id');
		}
		$result = $this->db->select('pl_id,pl_name,pl_buying_cost,pl_country,pl_supplier')
						   ->where('pl_prop_type',$id)
						   ->where('pl_delete_status','0')
						   ->where('pl_status','0')
						   ->order_by('pl_id','desc')
						   ->get('plans');
		return $result->result();
	}

	public function plan_list_by_country($id){
		$result = $this->db->select('country_name,pl_id,country_logo,pl_name,pl_cost,pl_validity,pl_data_allowance')
						   ->join('country','country_id = pl_country')
						   ->where('country_id',$id)
						   ->where('pl_delete_status','0')
						   ->order_by('pl_id','desc')
						   ->get('plans');
		return $result->result();
	}

	//rechargable topup code - 12-04-2024
	public function get_plan_by_supplier($id){
		$qry = $this->db->select('pl_id,pl_name,pl_buying_cost')->where('pl_supplier',$id)->get('plans');
		return $qry->result_Array();
	}

	public function get_plancost_by_plan($id){
		$qry = $this->db->select('pl_buying_cost')->where('pl_id',$id)->get('plans');
		return $qry->row();
	}

	public function get_supplier_country_cost_by_plan($id){
		$qry = $this->db->select('pl_buying_cost,pl_id,pl_supplier,pl_country,pl_region,country_id,country_name,sp_id,sp_name,r_id,r_name')
						->join('suppliers','sp_id = pl_supplier')
						->join('country','country_id = pl_country','left')
						->join('regions','r_id = pl_region','left')
						->where('pl_id',$id)
						->get('plans');
		return $qry->row();
	}

	public function get_topup_byID($id){
		$result = $this->db->where('tp_id',$id)->get('rechargable_topups')->row();
		return $result;
	}

	public function delete_topup_byID($id){
		$table = "rechargable_topups";
		$data = array('tp_delete_status'=>'1');
		$this->db->where('tp_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function change_topup_status_byID($id){
		$table = "rechargable_topups";
		$qry = $this->db->select('tp_status')->where('tp_id',$id)->get($table)->row();
		$prev_status = $qry->tp_status;
		$new_status = "0";
		if($prev_status == '0'){
			$new_status = "1";
		}else if($prev_status == '1'){
			$new_status = "0";
		}
		$data = array('tp_status'=> $new_status);
		$this->db->where('tp_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function create_new_topup(){
		date_default_timezone_set('Asia/Kolkata');
		$data = array('tp_supplier_id' => $this->input->post('tp_supplier'),
					  'tp_plan_id' => $this->input->post('tp_plan'),
					  'tp_plan_cost' => $this->input->post('tp_cost'),
					  'tp_topup_name' => $this->input->post('tp_name'),
					  'tp_price' => $this->input->post('tp_price'),
					  'tp_price_currency' => $this->input->post('tp_price_currency'),
					  'tp_data_allowance' => $this->input->post('tp_data_allowance'),
					  'tp_data_allow_type' => $this->input->post('tp_data_allow_type'),
					  'tp_validity' => $this->input->post('tp_validity'),
					  'tp_info' => $this->input->post('tp_info'),
					  'tp_created_date' => date('Y-m-d h:i:s')
	    			);
		if($this->input->post('cid') !=""){
			$this->db->where('tp_id',$this->input->post('cid'));
			$result = $this->db->update('rechargable_topups',$data);
		}else{
			$result = $this->db->insert('rechargable_topups',$data);
		}
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getallrechargable_topups($type,$where_data){
		$table = "rechargable_topups";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('tp_id');		
		}
		$this->db->where('tp_delete_status','0');
		$this->db->from($table);
		$this->db->join('plans','pl_id = tp_plan_id');
		$this->db->join('country','country_id = tp_country_id','left');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('tp_topup_name', addslashes($where_data['search']));
			$this->db->or_like('tp_price', addslashes($where_data['search']));
			$this->db->or_like('tp_data_allowance', addslashes($where_data['search']));
			$this->db->or_like('tp_validity', addslashes($where_data['search']));					
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('tp_id', 'tp_price','tp_data_allowance','tp_topup_name','tp_data_allow_type','tp_validity','tp_status')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('tp_id','desc');
			}
		}

		$this->db->group_by('tp_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	// supplier code
	public function add_supplier($cdrapi){
		
		$data = array('sp_type' => $this->input->post('sp_type'),
					  'sp_country' => $this->input->post('sp_country'),
					  'sp_name' => $this->input->post('sp_name'),
					  'sp_address' => $this->input->post('sp_address'),
					  'sp_contactPerson' => $this->input->post('sp_contactPerson'),
					  'sp_email' => $this->input->post('sp_email'),
					  'sp_phoneno' => $this->input->post('sp_phoneno'),
					  'sp_bufferstock' => $this->input->post('sp_bufferstock'),
					  'sp_currency' => $this->input->post('sp_currency'),
					  'sp_cdrapi' => $cdrapi
	    			 );
		
		$result = $this->db->insert('suppliers',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getallsuppliers($type,$where_data){
		$table = "suppliers";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('sp_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('sp_delete_status','0');
		$this->db->from($table);		
		$this->db->join('country','country_id=sp_country');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('sp_name', addslashes($where_data['search']));
			$this->db->or_like('country_name', addslashes($where_data['search']));
			$this->db->or_like('sp_contactPerson', addslashes($where_data['search']));
			$this->db->or_like('sp_type', addslashes($where_data['search']));			
			$this->db->or_like('sp_email', addslashes($where_data['search']));
			$this->db->or_like('sp_phoneno', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('sp_id','sp_name','country_name',
				'sp_status','sp_contactPerson','sp_type','sp_email','sp_phoneno','sp_bufferstock','sp_currency')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('sp_id','desc');
			}
		}

		$this->db->group_by('sp_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function delete_supplier_byID($id){
		$table = "suppliers";
		$data = array('sp_delete_status'=>'1');
		$this->db->where('sp_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_supplier_byID($id){
		$result = $this->db->where('sp_id',$id)->get('suppliers')->row();
		return $result;
	}

	public function edit_supplier($id,$new_file){
		$prev_file="";
		if($id!=""){
				$this->db->select('sp_cdrapi');
				$this->db->where('sp_id',$id);
				$res = $this->db->get('suppliers')->row();
				$prev_file = $res->sp_cdrapi;
		}
		if($new_file==""){
			$new_file = $prev_file;
		}
		$data = array('sp_type' => $this->input->post('sp_type'),
					  'sp_country' => $this->input->post('sp_country'),
					  'sp_name' => $this->input->post('sp_name'),
					  'sp_address' => $this->input->post('sp_address'),
					  'sp_contactPerson' => $this->input->post('sp_contactPerson'),
					  'sp_email' => $this->input->post('sp_email'),
					  'sp_phoneno' => $this->input->post('sp_phoneno'),
					  'sp_bufferstock' => $this->input->post('sp_bufferstock'),
					  'sp_currency' => $this->input->post('sp_currency'),
					  'sp_cdrapi' => $new_file
	    			 );
		$this->db->where('sp_id',$id);
		$result = $this->db->update('suppliers',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function supplierList(){
		$result = $this->db->where('sp_delete_status','0')->get('suppliers')->result();
		return $result;
	}

	public function guidlineList(){
		$result = $this->db->where('gd_delete_status','0')->get('guidelines')->result();
		return $result;
	}
	// operator code

	public function add_operator(){
		
		$data = array('op_name' => $this->input->post('op_name'));
		
		$result = $this->db->insert('operators',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getalloperators($type,$where_data){
		$table = "operators";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('op_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('op_delete_status','0');
		$this->db->from($table);
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('op_name', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('op_id','op_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('op_id','desc');
			}
		}

		$this->db->group_by('op_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function delete_operator_byID($id){
		$table = "operators";
		$data = array('op_delete_status'=>'1');
		$this->db->where('op_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_operator_byID(){
		$id = $this->input->post('id');
		$result = $this->db->where('op_id',$id)->get('operators')->row();
		return $result;
	}

	public function edit_operator(){
		$id = $this->input->post('cid');
		$data = array('op_name' => $this->input->post('op_name'));
		$this->db->where('op_id',$id);
		$result = $this->db->update('operators',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	// network code

	public function add_network(){
		
		$data = array('nt_name' => $this->input->post('nt_name'));
		
		$result = $this->db->insert('networks',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getallnetworks($type,$where_data){
		$table = "networks";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('nt_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('nt_delete_status','0');
		$this->db->from($table);
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('nt_name', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('nt_id','nt_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('nt_id','desc');
			}
		}

		$this->db->group_by('nt_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function delete_network_byID($id){
		$table = "networks";
		$data = array('nt_delete_status'=>'1');
		$this->db->where('nt_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_network_byID(){
		$id = $this->input->post('id');
		$result = $this->db->where('nt_id',$id)->get('networks')->row();
		return $result;
	}

	public function edit_network(){
		$id = $this->input->post('cid');
		$data = array('nt_name' => $this->input->post('nt_name'));
		$this->db->where('nt_id',$id);
		$result = $this->db->update('networks',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	//Affiliates

	public function getallAffiliate($type,$where_data)
	{ 
		$table = "affiliates";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('af_id');		
		}
		$this->db->where('af_deleted_status','0');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('af_name', addslashes($where_data['search']));
			$this->db->or_like('af_email', addslashes($where_data['search']));
			$this->db->or_like('af_reference', addslashes($where_data['search']));	
			$this->db->or_like('af_createdOn', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('af_id', 'af_name','af_email','af_reference','af_createdOn')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('af_id','desc');
			}
		}

		$this->db->group_by('af_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

    public function add_affiliate(){
        $table = "affiliates";
		
		$data = array('af_name'=>strtolower($this->input->post('af_name')),
						'af_email'=>$this->input->post('af_email'),
						'af_reference'=>$this->input->post('af_reference'));
		if($this->input->post('cid')!=""){
			$this->db->where('af_id',$this->input->post('cid'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
    }

    public function get_affiliate_byID(){
        $table = "affiliates";
		$this->db->where('af_id',$this->input->post('id'));
		$res = $this->db->get($table);
		return $res->row();
    }

    public function delete_affiliate_byID($id){
        $table = "affiliates";
		$data = array('af_deleted_status'=>'1');
		$this->db->where('af_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function affiliateList(){
		$query = $this->db->select('af_id, af_name')->where('af_deleted_status','0')->get('affiliates');
		return $query->result();
	}

	public function getAllenquiries($type,$where_data){
		$table = "enquiries";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('eq_id');		
		}
		$this->db->where('eq_deleted_status','0');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('eq_fname', addslashes($where_data['search']));
			$this->db->like('eq_lname', addslashes($where_data['search']));
			$this->db->or_like('eq_email', addslashes($where_data['search']));
			$this->db->or_like('eq_phone', addslashes($where_data['search']));	
			$this->db->or_like('eq_esidID', addslashes($where_data['search']));		
			$this->db->or_like('eq_subject', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('eq_id', 'eq_fname', 'eq_lname', 'eq_email','eq_phone','eq_esidID','eq_subject')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('eq_id','desc');
			}
		}

		$this->db->group_by('eq_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	// Partner code

	public function add_partner(){
	
		$data = array('pt_company_name' => $this->input->post('pt_company_name'),
						'pt_spoc' => $this->input->post('pt_spoc'),
						'pt_phone' => $this->input->post('pt_phone'),
						'pt_email' => $this->input->post('pt_email'),
						'pt_address' => $this->input->post('pt_address'),
						'pt_website' => $this->input->post('pt_website'),
						'pt_discount' => $this->input->post('pt_discount')
						);
		
		$result = $this->db->insert('partners',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getallpartners($type,$where_data){
		$table = "partners";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('pt_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('pt_delete_status','0');
		$this->db->from($table);
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('pt_company_name', addslashes($where_data['search']));
			$this->db->or_like('pt_spoc', addslashes($where_data['search']));
			$this->db->or_like('pt_phone', addslashes($where_data['search']));			
			$this->db->or_like('pt_email', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pt_id','pt_company_name','pt_spoc',
				'pt_status','pt_phone','pt_email')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('pt_id','desc');
			}
		}

		$this->db->group_by('pt_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function delete_partner_byID($id){
		$table = "partners";
		$data = array('pt_delete_status'=>'1');
		$this->db->where('pt_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_partner_byID($id){
		$result = $this->db->where('pt_id',$id)->get('partners')->row();
		return $result;
	}

	public function edit_partner($id){
				
		$data = array('pt_company_name' => $this->input->post('pt_company_name'),
						'pt_spoc' => $this->input->post('pt_spoc'),
						'pt_phone' => $this->input->post('pt_phone'),
						'pt_email' => $this->input->post('pt_email'),
						'pt_address' => $this->input->post('pt_address'),
						'pt_website' => $this->input->post('pt_website'),
						'pt_discount' => $this->input->post('pt_discount')
						);
		$this->db->where('pt_id',$id);
		$result = $this->db->update('partners',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function view_inventory(){
		if($this->input->post('partner_id')!="" && $this->input->post('partner_id') > 0){
			$this->db->select('plans.pl_name,inventory.i_activation_code,inventory.i_code_available_status,inventory.i_id');
			$this->db->where('i_partner_id',$this->input->post('partner_id'));
			$this->db->where('i_delete_status','0');
			$this->db->join('plans','pl_id = i_plan_id');
			$res = $this->db->get('inventory');
			return $res->result();
		}
	}

	//complaints
	public function getallComplaints($type,$where_data)
	{ 
		$table = "complaints";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('cm_id');		
		}
		$this->db->where('cm_delete_status','0');
        $this->db->join('product_types','product_types.p_id=complaints.cm_prod_type');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('cm_comp', addslashes($where_data['search']));
			$this->db->or_like('p_name', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('cm_id', 'p_name','cm_comp','cm_status','cm_createdOn')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('cm_id','desc');
			}
		}

		$this->db->group_by('cm_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

    public function add_complaint(){
        $table = "complaints";
		
		$data = array('cm_comp'=>strtolower($this->input->post('cm_comp')),
						'cm_prod_type'=>$this->input->post('cm_prod_type'));
		if($this->input->post('cid')!=""){
			$this->db->where('cm_id',$this->input->post('cid'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
    }

    public function get_complaint_byID(){
        $table = "complaints";
		$this->db->where('cm_id',$this->input->post('id'));
		$res = $this->db->get($table);
		return $res->row();
    }

    public function delete_complaint_byID($id){
        $table = "complaints";
		$data = array('cm_delete_status'=>'1');
		$this->db->where('cm_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	//sub complaints

	public function getallsub_complaints($type,$where_data)
	{ 
		$table = "sub_complaints";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('sc_id');		
		}
		$this->db->where('sc_delete_status','0');
        $this->db->join('product_types','product_types.p_id=sub_complaints.sc_prod_type');
        $this->db->join('complaints','complaints.cm_id=sub_complaints.sc_comp');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
            $this->db->or_like('sc_subComp', addslashes($where_data['search']));
			$this->db->like('cm_comp', addslashes($where_data['search']));
			$this->db->or_like('p_name', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('sc_id','p_name','cm_comp','sc_subComp','sc_status','sc_createdOn')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('sc_id','desc');
			}
		}

		$this->db->group_by('sc_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

    public function add_sub_complaint(){
        $table = "sub_complaints";
		
		$data = array('sc_subComp'=>strtolower($this->input->post('sc_subComp')),
						'sc_prod_type'=>$this->input->post('sc_prod_type'),
                        'sc_comp'=>$this->input->post('sc_comp'));
		if($this->input->post('cid')!=""){
			$this->db->where('sc_id',$this->input->post('cid'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
    }

    public function get_sub_complaint_byID(){
        $table = "sub_complaints";
		$this->db->where('sc_id',$this->input->post('id'));
		$res = $this->db->get($table);
		return $res->row();
    }

    public function delete_sub_complaint_byID($id){
        $table = "sub_complaints";
		$data = array('sc_delete_status'=>'1');
		$this->db->where('sc_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function getproductList(){
		$this->db->where('p_delete_status','0');
		$this->db->order_by('p_id','desc');
		$result = $this->db->get('product_types');
		return $result->result();
	}

	public function getcomplaintsList(){
		$this->db->where('cm_delete_status','0');
		$this->db->order_by('cm_id','desc');
		$result = $this->db->get('complaints');
		return $result->result();
	}

	public function getalltickets($type,$where_data)
	{ 
		$table = "tickets";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('t_id');		
		}
		$this->db->where('t_delete_status','0');
        $this->db->join('complaints','complaints.cm_id=tickets.t_complaint');
		$this->db->join('sub_complaints','sub_complaints.sc_id=tickets.t_sub_complaint');
		$this->db->join('users','u_id = t_user_id');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
            $this->db->or_like('sc_subComp', addslashes($where_data['search']));
			$this->db->like('cm_comp', addslashes($where_data['search']));
			$this->db->or_like('t_esim_iccid', addslashes($where_data['search']));	
			$this->db->or_like('t_user_type', addslashes($where_data['search']));	
			$this->db->or_like('u_name', addslashes($where_data['search']));
			$this->db->or_like('t_ticket_status', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('t_id','t_ticket_status','cm_comp','sc_subComp','t_user_name','t_user_type','t_esim_iccid','t_close_date','t_createdOn')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('t_id','desc');
			}
		}

		$this->db->group_by('t_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function view_ticket($id){
		$this->db->where('t_id',$id);
		$this->db->join('complaints','complaints.cm_id=tickets.t_complaint');
		$this->db->join('sub_complaints','sub_complaints.sc_id=tickets.t_sub_complaint');
		$this->db->join('users','u_id = t_user_id');
		$response = $this->db->get('tickets')->row();
		return $response;
	}

	public function update_ticket_status(){
		
		$data = array('t_admin_remarks' => $this->input->post('admin_remarks'),
					  't_ticket_status' => $this->input->post('ticket_status'),
					  't_close_date' => date('Y-m-d H:i:s'));
		
		$this->db->where('t_id',$this->input->post('tid'));
		$response = $this->db->update('tickets',$data);
		if($response){
			return true;
		}else{
			return false; 
		}
	}

	//esim devices
	public function getalldevices($type,$where_data)
	{ 
		$table = "esimdevices";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('ed_id');		
		}
		$this->db->where('ed_delete_status','0');
        $this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('ed_title', addslashes($where_data['search']));
			$this->db->or_like('ed_devices', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('ed_id', 'ed_title','ed_devices','ed_delete_status','ed_createdOn')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('ed_id','desc');
			}
		}

		$this->db->group_by('ed_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

    public function add_device(){
        $table = "esimdevices";
		
		$data = array('ed_title'=>strtolower($this->input->post('ed_title')),
						'ed_devices'=>$this->input->post('editor1'));
		if($this->input->post('cid')!=""){
			$this->db->where('ed_id',$this->input->post('cid'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
    }

    public function get_device_byID(){
        $table = "esimdevices";
		$this->db->where('ed_id',$this->input->post('id'));
		$res = $this->db->get($table);
		return $res->row();
    }

    public function delete_device_byID($id){
        $table = "esimdevices";
		$data = array('ed_delete_status'=>'1');
		$this->db->where('ed_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function getEsimList(){
		$table = "esimdevices";
		$this->db->where('ed_delete_status','0');
		$this->db->order_by('ed_id','desc');
		$res = $this->db->get($table);
		return $res->result();
    }

	//coupon code start here

	public function getallcoupons($type,$where_data)
	{ 
		$table = "coupons";
		if($type=='data')
		{
			$this->db->select('coupons.*,plans.pl_id,plans.pl_name,country.country_id,
			country.country_name,regions.r_id,regions.r_name,affiliates.af_id,affiliates.af_name');   
		}
		else
		{
			$this->db->select('co_id');		
		}
		$this->db->where('co_deleted_status','0');
		$this->db->from($table);		
		$this->db->join('country','country_id = co_country_id','left');
		$this->db->join('regions','r_id = co_region_id','left');
		$this->db->join('affiliates','af_id = co_affiliate_id');
		$this->db->join('plans','pl_id = co_plan_id','left');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->or_like('af_name', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('co_id', 'co_code', 'af_name', 'co_commission', 'co_issue_date', 'co_expiry_date','country_name','r_name','pl_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('co_id','desc');
			}
		}

		$this->db->group_by('co_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function get_coupon_byID($id){
		$table = "coupons";
		//$id = $this->input->post('id');
		$res = $this->db->where('co_deleted_status','0')->where('co_id',$id)->get($table);
		return $res->row();
	}

	public function add_coupon(){
		date_default_timezone_set('Asia/Kolkata');
		$table = "coupons";
		$plan_list = "";
		if($this->input->post('request_type') == '2'){
			$plan_list = $this->db->select('pl_id')->where('pl_country',$this->input->post('co_country'))->get('plans')->result_array();
		
		}else if($this->input->post('request_type') == '3'){
			$plan_list = $this->db->select('pl_id')->where('pl_region',$this->input->post('co_region'))->get('plans')->result_array();
			
		}else{
			$plans = $this->input->post('co_plan');
		}
		if($plan_list != ""){
			$plan_array = array(); $i=0;
			foreach($plan_list as $each_pl){
				$plan_array[$i] = $each_pl['pl_id'];
			$i++;}
			
			$plans = implode(',',$plan_array);
		}
		$data = array('co_affiliate_id' => $this->input->post('co_affiliate'),
					  'co_code' => $this->input->post('co_code'),
					  'co_discount_percent' => $this->input->post('co_discount_percent'),
					  'co_issue_date' => date('Y-m-d h:i:s', strtotime($this->input->post('co_issue_date'))),
					  'co_expiry_date' => date('Y-m-d h:i:s', strtotime($this->input->post('co_expiry_date'))),
					  'co_country_id' => $this->input->post('co_country'),
					  'co_region_id' => $this->input->post('co_region'),
					  'co_plan_id' => $plans,
					  'co_specification' => $this->input->post('request_type'),
					  'co_created_date' => date('Y-m-d h:i:s')
					);
		if($this->input->post('id') !=""){
			$this->db->where('co_id',$this->input->post('id'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function delete_coupon_byID($id){
        $table = "coupons";
		$data = array('co_deleted_status'=>'1');
		$this->db->where('co_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function change_status_coupon(){
		$table = "coupons";
		$id = $this->input->post('new_id');
		$co_status = $this->db->select('co_status')->where('co_id',$id)->get($table)->row()->co_status;
		
		if($co_status == '0'){
			$status = '1';
		}else if($co_status == '1'){
			$status = '0';
		}
		$data = array('co_status'=> $status);
		$this->db->where('co_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	//faqs

	public function getallfaq($type,$where_data)
	{ 
		$table = "faq";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('fq_id');		
		}
		$this->db->where('fq_delete_status','0');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('fq_question', addslashes($where_data['search']));
			$this->db->or_like('fq_answer', addslashes($where_data['search']));		
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('fq_id', 'fq_question','fq_answer')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('fq_id','desc');
			}
		}

		$this->db->group_by('fq_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

    public function add_faq(){
        $table = "faq";
		
		$data = array('fq_question'=>strtolower($this->input->post('fq_question')),
						'fq_answer'=>$this->input->post('fq_answer'));
		if($this->input->post('cid')!=""){
			$this->db->where('fq_id',$this->input->post('cid'));
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
    }

    public function get_faq_byID(){
        $table = "faq";
		$this->db->where('fq_id',$this->input->post('id'));
		$res = $this->db->get($table);
		return $res->row();
    }

    public function delete_faq_byID($id){
        $table = "faq";
		$data = array('fq_delete_status'=>'1');
		$this->db->where('fq_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
    }

	public function get_terms_condition(){
		$table = "terms_conditions";
		$qry = $this->db->get($table);
		return $qry->row();
	}

	public function save_terms_condition(){
		$table = "terms_conditions";
		
		$data = array('tc_details' => $this->input->post('data'));
		$cnt = $qry = $this->db->get($table)->num_rows();
		if($cnt > 0){
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_privacypolicy(){
		$table = "privacypolicy";
		$qry = $this->db->get($table);
		return $qry->row();
	}

	public function save_privacypolicy(){
		$table = "privacypolicy";
		$data = array('pp_details' => $this->input->post('data'));
		$cnt = $qry = $this->db->get($table)->num_rows();
		if($cnt > 0){
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_refundpolicy(){
		$table = "refundpolicy";
		$qry = $this->db->get($table);
		return $qry->row();
	}

	public function save_refundpolicy(){
		$table = "refundpolicy";
		
		$data = array('rp_details' => $this->input->post('data'));
		$cnt = $qry = $this->db->get($table)->num_rows();
		if($cnt > 0){
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function get_index_banner(){
		$table = "banners";
		$qry = $this->db->get($table);
		return $qry->row();
	}

	public function save_index_banner($banner_image){
		$table = "banners";
		if($banner_image !=""){
			$banner = $banner_image;
		}else if($this->input->post('prev_banner') != ""){
			$banner = $this->input->post('prev_banner');
		}else{
			$banner = "";
		}

		$data = array('bn_image' => $banner);
		$cnt = $qry = $this->db->get($table)->num_rows();
		if($cnt > 0){
			$res = $this->db->update($table,$data);
		}else{
			$res = $this->db->insert($table,$data);
		}
		
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function getallplan_orders($type,$where_data){
		$table = "plans";
		if($type=='data')
		{
			$this->db->select('pl_id,pl_name,pl_top_seller,pl_best_Seller,pl_order,pl_kyc_status,pl_stock_value,country_id,country_name');   
		}
		else
		{
			$this->db->select('pl_id');		
		}
		//$this->db->where('pl_status','0');
		
		if(isset($where_data['country']) && $where_data['country'] != '')
		{
			$this->db->where('pl_country',$where_data['country']);
		}else{
			$this->db->where('pl_country','');
		}

		$this->db->where('pl_delete_status','0');
		$this->db->from($table);		
		$this->db->join('country','country_id=pl_country');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('pl_name', addslashes($where_data['search']));
			$this->db->or_like('country_name', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pl_id','pl_name','country_name','pl_status')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('pl_id','desc');
			}
		}

		$this->db->group_by('pl_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function get_order_data($id){
		$this->db->select('pl_id,pl_name,pl_top_seller,pl_best_Seller,pl_order,pl_kyc_status,pl_stock_value');
		$this->db->where('pl_id',$id);
		$qry = $this->db->get('plans');
		return $qry->row();
	}

	public function update_order_data(){
		$table = 'plans';
		$data =   array('pl_order' => $this->input->post('o_order'),
						'pl_best_Seller' => $this->input->post('o_best_Seller'),
						'pl_top_seller' => $this->input->post('o_top_Seller'),
						'pl_kyc_status' => $this->input->post('o_kyc_Status'),
						'pl_stock_value' => $this->input->post('o_stock_value'));
						
		$this->db->where('pl_id',$this->input->post('o_id'));
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function add_contact(){
		$data = array('eq_name' 	=> $this->input->post('name'),
					  'eq_email' 	=> $this->input->post('email'),
					  'eq_phone' 	=> $this->input->post('contactno'),
					  'eq_subject'  => $this->input->post('subject'),
					  'eq_message'  => $this->input->post('message')
					);
		$res = $this->db->insert('enquiries',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function add_partner_enquiry(){
		
		$data = array('pe_company_name' 	=> $this->input->post('company_name'),
					  'pe_website' 			=> $this->input->post('website'),
					  'pe_country' 			=> $this->input->post('country'),
					  'pe_contact_name'  	=> $this->input->post('contact_name'),
					  'pe_email' 			=> $this->input->post('email'),
					  'pe_contactno' 		=> $this->input->post('contactno'),
					  'pe_info'  			=> $this->input->post('info')
					);
		$res = $this->db->insert('partner_enquiries',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}
//  Inventory Quick tool code starts here
//  Date : 07-05-2024
//  Auther : RPSakode
	public function add_new_inventory(){
		date_default_timezone_set('Asia/Kolkata');
		$data = array(  
			'i_plan_id' => $this->input->post('each_plan_name'),
			'i_activation_code' => $this->input->post('each_plan_activation_code'),
			'i_sim_pin' => $this->input->post('each_plan_sim_pin'),
			'i_iccid' => $this->input->post('each_plan_iccid'),
			'i_service_id' => $this->input->post('each_plan_service_device'),
			'i_sim_status' => ($this->input->post('each_plan_sim_status')!==null?$this->input->post('each_plan_sim_status'):'0'),
			'i_stock_status' => ($this->input->post('each_plan_stock_status')!==null?$this->input->post('each_plan_stock_status'):'0'),
			'i_selling_price' => ($this->input->post('each_plan_selling_price')!==null?$this->input->post('each_plan_selling_price'):'0.00'),
			'i_remarks' => ($this->input->post('each_plan_remarks')!==null?$this->input->post('each_plan_remarks'):""),
			'i_created_date' => date('Y-m-d h:i:s'),
			'i_updated_date' => date('Y-m-d h:i:s')
		);
		$check_plan = $this->db->where('i_plan_id',$this->input->post('each_plan_name'))->where('i_delete_status','0')->get('inventory')->row();
		// if(isset($check_plan) && $check_plan!= ""){
		// 	$this->db->where('i_plan_id',$this->input->post('each_plan_name'));
		// 	$res = $this->db->update('inventory',$data);
		// }else 
		if($this->input->post('id') !="" && $this->input->post('id') > 0){ 
			$this->db->where('i_id',$this->input->post('id'));
			$res = $this->db->update('inventory',$data);
		}else{
			$res = $this->db->insert('inventory',$data);
		}

		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function getEachInventoryDetails($id){
		$this->db->select('inventory.*,plans.pl_id,plans.pl_name,plans.pl_buying_cost,plans.pl_prop_type,country.country_id,country.country_name,regions.r_id,regions.r_name,suppliers.sp_name,suppliers.sp_id'); 
		$this->db->where('i_delete_status','0');
		$this->db->where('i_id',$id);
		$this->db->join('inventory','pl_id=i_plan_id');
		$this->db->join('suppliers','sp_id=pl_supplier','left');
		$this->db->join('country','country_id=pl_country','left');
		$this->db->join('regions','r_id=pl_region','left');
		$result = $this->db->get('plans');
		return $result->row();
	}

	// public function getallinventory($type,$where_data){
	// 	$table = "plans";
	// 	if($type=='data')
	// 	{
	// 		$this->db->select('inventory.*,plans.pl_id,plans.pl_name,plans.pl_buying_cost,plans.pl_prop_type,country.country_name,regions.r_name,suppliers.sp_name');   
	// 	}
	// 	else
	// 	{
	// 		$this->db->select('i_id');		
	// 	}
	// 	//$this->db->where('pl_status','0');
	// 	$this->db->where('i_delete_status','0');
	// 	$this->db->from($table);
	// 	$this->db->join('inventory','pl_id=i_plan_id');
	// 	$this->db->join('suppliers','sp_id=pl_supplier','left');
	// 	$this->db->join('country','country_id=pl_country','left');
	// 	$this->db->join('regions','r_id=pl_region','left');
		
	// 	if(isset($where_data['plan']) && $where_data['plan'] != '')
	// 	{
	// 		$this->db->where('i_plan_id',$where_data['plan']);
	// 	}
		
	// 	if(isset($where_data['search']) && $where_data['search'] != '')
	// 	{	
	// 		$this->db->group_start();
	// 		$this->db->like('sp_name', addslashes($where_data['search']));
	// 		$this->db->or_like('pl_name', addslashes($where_data['search']));
	// 		$this->db->or_like('country_name', addslashes($where_data['search']));
	// 		$this->db->or_like('r_name', addslashes($where_data['search']));
	// 		$this->db->or_like('i_activation_code', addslashes($where_data['search']));
	// 		$this->db->group_end();
	// 	}

		

	// 	//pagination and sorting
	// 	if(isset($where_data['per_page']) && $type == 'data')
	// 	{
	// 		$limit = $where_data['per_page'];

	// 		if($where_data['page'] != 0)
	// 		{
	// 			$page = --$where_data['page'];
	// 		}
	// 		else
	// 		{
	// 			$page = $where_data['page'];
	// 		}

	// 		$this->db->limit($limit, $page*$limit);
	// 	}

	// 	if(isset($where_data['sort_by']) && $type == 'data')
	// 	{
	// 		// Set sorting
	// 		if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
	// 		{				
	// 			if(in_array($where_data['sort_by'], array('i_id','pl_name,sp_name')))
	// 			{
	// 				$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
	// 			}
	// 		}
	// 		else
	// 		{
	// 			// Set default sorting
	// 			$this->db->order_by('i_id','desc');
	// 		}
	// 	}

	// 	$this->db->group_by('i_id');
		
	// 	// If data is required
	// 	if($type == 'data')
	// 	{
	// 		$result = $this->db->get()->result_array();			
	// 	}   
	// 	else
	// 	{
	// 		$result = $this->db->get()->num_rows();			
	// 	}
	// 	//print_r($this->db->last_query());die;
	// 	return $result;	
	// }

	public function getallinventory($type,$where_data){
		$table = "plans";
		if($type=='data')
		{
			$this->db->select('inventory.*,plans.pl_id,plans.pl_name,plans.pl_buying_cost,plans.pl_prop_type,country.country_name,regions.r_name,suppliers.sp_name');   
		}
		else
		{
			$this->db->select('i_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('i_delete_status','0');
		$this->db->from($table);
		$this->db->join('inventory','pl_id=i_plan_id');
		$this->db->join('suppliers','sp_id=pl_supplier','left');
		$this->db->join('country','country_id=pl_country','left');
		$this->db->join('regions','r_id=pl_region','left');
		
		if(isset($where_data['plan']) && $where_data['plan'] != '')
		{
			$this->db->where('i_plan_id',$where_data['plan']);
		}
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('sp_name', addslashes($where_data['search']));
			$this->db->or_like('pl_name', addslashes($where_data['search']));
			$this->db->or_like('country_name', addslashes($where_data['search']));
			$this->db->or_like('r_name', addslashes($where_data['search']));
			$this->db->or_like('i_activation_code', addslashes($where_data['search']));
			$this->db->group_end();
		}

		

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('i_id','pl_name,sp_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('i_id','desc');
			}
		}

		$this->db->group_by('i_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function insert_batch($data,$table){
        $this->db->insert_batch($table,$data);
        if($this->db->affected_rows() >0){
            return true;
        }else{
            return false;
        }
    }

	public function get_inventory_remarks(){
		$result = $this->db->select('i_remarks')->where('i_id',$this->input->post('new_id'))->get('inventory');
		return $result->row();
	}

	public function update_inventory_remarks(){
		$data = array('i_remarks' => $this->input->post('i_remarks'));
		$this->db->where('i_id',$this->input->post('i_id'));
		$result = $this->db->update('inventory',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function get_selling_price(){
		$result = $this->db->select('i_selling_price,pl_name,pl_id')
		->where('i_id',$this->input->post('new_id'))->join('plans','pl_id=i_plan_id')->get('inventory');
		return $result->row();
	}

	public function update_inventory_selling_price(){
		$data = array('i_selling_price' => $this->input->post('i_selling_price'));
		$this->db->where('i_id',$this->input->post('i_inv_id'));
		$result = $this->db->update('inventory',$data);
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function get_sub_complaints(){
		$this->db->where('sc_comp',$this->input->post('id'));
		$this->db->where('sc_delete_status','0');
		$res = $this->db->get('sub_complaints');
		return $res->result_array();
	}

	public function getAllorders($type,$where_data){
		
		$table = "orders";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('o_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('o_status','0');
		$this->db->from($table);
		$this->db->join('payments','pm_id=o_payment_id');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('o_user_email', addslashes($where_data['search']));
			$this->db->or_like('o_plan_name', addslashes($where_data['search']));
			$this->db->or_like('o_geography', addslashes($where_data['search']));
			$this->db->or_like('o_activation_code', addslashes($where_data['search']));
			$this->db->group_end();
		}

		if(isset($where_data['plan']) && $where_data['plan'] != '')
		{
			$this->db->where('o_plan_id',$where_data['plan']);
		}

		if($where_data['start_date'] != "" && $where_data['end_date'] != ""){
			$this->db->where('o_created_on >=',$where_data['start_date']);
			$this->db->where('o_created_on <= ',$where_data['end_date']);
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('o_id','o_plan_name','o_user_email','o_geography','o_activation_code')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('o_id','desc');
			}
		}

		$this->db->group_by('o_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	//get all payments 
	public function getAllpayments($type,$where_data){
		$table = "payments";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('pm_id');		
		}
		
		$this->db->from($table);
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start(); 
			$this->db->like('pm_order_id', addslashes($where_data['search']));
			$this->db->or_like('pm_transc_id', addslashes($where_data['search']));
			$this->db->or_like('pm_amount_total', addslashes($where_data['search']));
			$this->db->or_like('pm_customer_email', addslashes($where_data['search']));
			$this->db->or_like('pm_status', addslashes($where_data['search']));
			$this->db->or_like('pm_payment_method', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pm_id','pm_order_id','pm_transc_id','pm_amount_total','pm_customer_email','pm_status','pm_payment_method')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('pm_id','desc');
			}
		}

		$this->db->group_by('pm_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	
	public function getAllpartner_enquiries($type,$where_data){
		$table = "partner_enquiries";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('pe_id');		
		}
		$this->db->where('pe_delete_status','0');
		$this->db->from($table);		
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start(); 
			$this->db->like('pe_company_name', addslashes($where_data['search']));
			$this->db->or_like('pe_website', addslashes($where_data['search']));
			$this->db->or_like('pe_country', addslashes($where_data['search']));
			$this->db->or_like('pe_contact_name', addslashes($where_data['search']));	
			$this->db->or_like('pe_email', addslashes($where_data['search']));		
			$this->db->or_like('pe_contactno', addslashes($where_data['search']));	
			$this->db->or_like('pe_info', addslashes($where_data['search']));		
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pe_id', 'pe_company_name', 'pe_website', 'pe_country','pe_contact_name','pe_email','pe_info', 'pe_contactno')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('pe_id','desc');
			}
		}

		$this->db->group_by('pe_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function delete_partner_enquiry_byID($id){
		$table = "partner_enquiries";
		$data = array('pe_delete_status'=>'1');
		$this->db->where('pe_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	//pre-fill partner enquiry details to add partner
	public function get_partner_enq_byID($id){
		return $this->db->where('pe_id',$id)->get('partner_enquiries')->row();
	}

	public function change_inventory_stock_status_byID($id){
		$table = "inventory";
		$qry = $this->db->select('i_stock_status')->where('i_id',$id)->get($table)->row();
		$prev_status = $qry->i_stock_status;
		$new_status = "0";
		if($prev_status == '0'){
			$new_status = "1";
		}else if($prev_status == '1'){
			$new_status = "0";
		}
		$data = array('i_stock_status'=> $new_status);
		$this->db->where('i_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function delete_inventory($id){
		$table = "inventory";
		$data = array('i_delete_status'=>'1');
		$this->db->where('i_id',$id);
		
		$res = $this->db->update($table,$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function getInventoryListByPlan(){
		$res = $this->db->select('i_id,i_activation_code')
		->where('i_stock_status','0')
		->where('i_code_available_status','Y')
		->where('i_plan_id',$this->input->post('plan_id'))
		->limit($this->input->post('id'),'0')
		->get('inventory');
		return $res->result_array();
	}

	public function send_code_with_partner(){
		//print_r($activation_ids);die;
		$activation_ids = $this->input->post('activation_code');

		$data = array('i_selling_price' => $this->input->post('selling_cost'),
					  'i_partner_id' => $this->input->post('partner_id'),
					  'i_code_available_status' => 'T');
		$res = "";
		
		if(sizeof($activation_ids) > 0){ 
			for($i=0; $i< sizeof($activation_ids);$i++){
				$this->db->where('i_id',$activation_ids[$i]);
				$res = $this->db->update('inventory',$data);
			}
		}

		if($res){
			return true;
		}else{
			return false;
		}
		
	}

	// Billing Section code starts here..

	public function add_new_offline_customer(){
		$data = array('oc_first_name' 	=> $this->input->post('oc_first_name'),
					  'oc_last_name'  	=> $this->input->post('oc_last_name'),
					  'oc_contact'  	=> $this->input->post('oc_contact'),
					  'oc_email'  		=> $this->input->post('oc_email'),
					  'oc_address'  	=> $this->input->post('oc_address'),
					  'oc_source'  		=> $this->input->post('oc_source'));

		
		if($this->input->post('cid') !=""){
			$this->db->where('oc_id',$this->input->post('cid'));
			$result = $this->db->update('offline_customers',$data);
		}else{
			$result = $this->db->insert('offline_customers',$data);
		}
		if($result){
			return true;
		}else{
			return false;
		}
	}

	public function getOfflineCustomers(){
		$rest = $this->db->where('oc_delete_status','0')->get('offline_customers');
		return $rest->result_array();
	}

	//kyc users
	public function getallkycusers($type,$where_data){
		$table = "kyc_details";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('k_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->join('users','u_id = k_user_id');
		$this->db->join('plans','pl_id = k_plan_id');
		$this->db->where('k_deleted_status','0');
		$this->db->from($table);
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('u_name', addslashes($where_data['search']));
			$this->db->like('u_email', addslashes($where_data['search']));
			$this->db->like('pl_name', addslashes($where_data['search']));
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('k_id','u_name','u_email','pl_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('k_id','desc');
			}
		}

		$this->db->group_by('k_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function get_kyc_user_data_byID($id){
		$table = "kyc_details";
		$rest = $this->db->where('k_id',$id)->get($table)->row();
		return $rest;
	}

	public function update_kyc_user_status(){
		$data = array('k_status' =>  $this->input->post('ky_status'), 
					  'k_remarks' => $this->input->post('ky_remarks')
					);
		$this->db->where('k_id',$this->input->post('id'));
		$res = $this->db->update('kyc_details',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	//kyc sale
	public function getallkycsale($type,$where_data){
		$table = "orders";
		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('o_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('o_status','0');
		$this->db->where('o_kyc_status','1');
		$this->db->from($table);
		$this->db->join('payments','pm_id=o_payment_id');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('o_user_email', addslashes($where_data['search']));
			$this->db->or_like('o_plan_name', addslashes($where_data['search']));
			$this->db->or_like('o_geography', addslashes($where_data['search']));
			$this->db->or_like('o_activation_code', addslashes($where_data['search']));
			$this->db->group_end();
		}

		if(isset($where_data['plan']) && $where_data['plan'] != '')
		{
			$this->db->where('o_plan_id',$where_data['plan']);
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('o_id','o_plan_name','o_user_email','o_geography','o_activation_code')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('o_id','desc');
			}
		}

		$this->db->group_by('o_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	
	}

	public function get_offline_plan_byID(){
		$this->db->join('country','country_id = pl_country','left');
		$this->db->join('regions','r_id = pl_region','left');
		$this->db->join('inventory','i_plan_id = pl_id');
		$this->db->where('i_code_available_status','Y');
		$this->db->where('i_delete_status','0');
		$this->db->order_by('i_id','desc');
		$this->db->limit('1','0');
		$this->db->where('pl_id',$this->input->post('id'));
		$result = $this->db->get('plans');
		return $result->row();
	}

	public function add_offline_plan(){
		date_default_timezone_set('Asia/Kolkata');
		$this->db->where('pl_id',$this->input->post('pl_id'));
		$this->db->join('country','country_id = pl_country','left');
		$this->db->join('regions','r_id = pl_region','left');
		$plan_data = $this->db->get('plans')->row();
		//echo '<pre>'; print_r($plan_data);
		$inventory_data = $this->db->where('i_id',$this->input->post('inv_id'))->get('inventory')->row();
		//echo '<br><hr><pre>'; print_r($inventory_data);

		$customer = $this->db->where('oc_id',$this->input->post('offline_cust'))->get('offline_customers')->row();
		$cust_name = $customer->oc_first_name." ".$customer->oc_last_name;
		$orderId = strtotime(date('Y-m-d H:i:s'));
		
			if($this->input->post('plan_activation_date') != ""){
				$activation_date = date('Y-m-d',strtotime($this->input->post('plan_activation_date')));
			}else{
				$activation_date = date('Y-m-d');
			}
			//calculate plan expiry date
			$exp_data = ""; $val_type = 'days';
			$validity = $plan_data->pl_validity;
			if($validity !=""){
				if($plan_data->pl_validity_type == '3'){
					$val_type = 'years';
				}else if($plan_data->pl_validity_type == '2'){
					$val_type = 'months';
				}else{
					$val_type = 'days';
				}
			}

			
		$exp_date =  date('Y-m-d',strtotime('+'.$validity.' '. $val_type,strtotime(str_replace('/', '-', date('Y-m-d'))))) . PHP_EOL;
		$geography = "";
		if($plan_data->pl_prop_type == "1"){
			$geography = $plan_data->country_name;
		}else{
			$geography = $plan_data->r_name;
		}
		$file = file_get_contents('https://quickchart.io/qr?text='.$inventory_data->i_activation_code.'&ecLevel=H&size=200');
		$activation_qrcode = 'EOD_' . $orderId . strtotime(date('d-m-Y')).'.png';
        file_put_contents('assets/qrcodes/'.$activation_qrcode, $file);

		$order_data = array(	'of_order_id'  		=> $orderId,
								'of_plan_id'	  	=> $plan_data->pl_id,
								'of_inventory_id' 	=> $inventory_data->i_id,
								'of_user_id' 		=> $customer->oc_id,
								'of_user_email' 	=> $customer->oc_email,
								'of_user_name' 		=> $cust_name,
								'of_geography' 		=> $geography,
								'of_validity' 		=> $validity." ".$val_type,
								'of_amount' 		=> $plan_data->pl_buying_cost,
								'of_plan_name' 		=> $plan_data->pl_name,
								'of_activation_code'=> $inventory_data->i_activation_code,
								'of_activation_img' => $activation_qrcode,
								'of_total' 			=> $this->input->post('selling_price'),
								'of_activation_date'=> $activation_date,
								'of_kyc_status' 	=> $plan_data->pl_kyc_status,
								'of_expiry_date' 	=> $exp_date
						);
						$result = $this->db->insert('offline_orders',$order_data);
						if($result){
							
							$set_status = array('i_code_available_status' => 'S');
							$this->db->where('i_id',$inventory_data->i_id)->update('inventory',$set_status);
							$mailsend = $this->send_success_mail($orderId);
							return true;
						}
		
	}
	
	public function send_success_mail($order_id){
		$response_data = $this->db->where('of_order_id',$order_id)->get('offline_orders')->result_array();
		if($response_data !="" && sizeof($response_data) >0){
			$this->email->initialize(array('mailtype'=>'html'));
			$this->email->from('info@digitalpatti.com', "Esimzon Team");
			$this->email->to($response_data[0]['of_user_email']);
			$this->email->subject("Order confirmation email");
				$message = "<div leftmargin='0' marginwidth='0' topmargin='0' marginheight='0' offset='0' style='height:auto !important;width:100% !important; font-family: Helvetica,Arial,sans-serif !important; margin-bottom: 40px;'>
							<center>
								<table bgcolor='#ffffff' border='0' cellpadding='0' cellspacing='0' style='max-width:600px; background-color:#ffffff;border:1px solid #e4e2e2;border-collapse:separate !important; border-radius:4px;border-spacing:0;color:#242128; margin:0;padding:40px;'
									heigth='auto'>
									<tbody>
										<tr>
											<td align='left' valign='center' style='padding-bottom:40px;border-top:0;height:100% !important;width:100% !important;'>
												<img src='".base_url()."assets/images/logo.png' style='width:100%'>
											</td>
											<td align='right' valign='center' style='padding-bottom:40px;border-top:0;height:100% !important;width:100% !important;'>
												<span style='color: #8f8f8f; font-weight: normal; line-height: 2; font-size: 14px;'><?php echo  date('d/m/Y'); ?></span>
											</td>
										</tr>
										<tr>
											<td colspan='2' style='padding-top:10px;border-top:1px solid #e4e2e2'>
												<h3 style='color:#303030; font-size:18px; line-height: 1.6; font-weight:500;'>Hello, ".ucwords($response_data[0]['of_user_name'])."</h3>";
							foreach($response_data as $each_response){
								$message .= "<div style='width:100%; padding:2rem; margin:2rem;border-bottom:1px solid #ddd;'>
													<div style='width:50%'>".$each_response['of_plan_name']."</div>
													<div style='width:50%'>".$each_response['of_activation_code']."</div>
											</div>";
							}
				$message .= "<h3 style='color:#303030; font-size:18px; line-height: 1.6; font-weight:500;'>Your order details : </h3>
												<p style='background-color:#f1f1f1; padding: 8px 15px; border-radius: 50px; display: inline-block; margin-bottom:20px; font-size: 14px;  line-height: 1.4; font-family: Courier New, Courier, monospace; margin-top:0'>Please scan the QR Code to activate your esim.</p>
											</td>
										</tr>
									</tbody>
								</table>
							</center>
						</div>";
			//print_r($message); die;
			$this->email->message($message);
			$this->email->send();
			return true;
		}else{
			return false;
		}
		
	}

	public function getallofflinesalereport($type,$where_data){
		$table = "offline_orders";

		if($type=='data')
		{
			$this->db->select('*');   
		}
		else
		{
			$this->db->select('of_id');		
		}
		//$this->db->where('pl_status','0');
		$this->db->where('of_status','0');
		
		$this->db->from($table);
		
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('of_user_email', addslashes($where_data['search']));
			$this->db->or_like('of_plan_name', addslashes($where_data['search']));
			$this->db->or_like('of_geography', addslashes($where_data['search']));
			$this->db->or_like('of_activation_code', addslashes($where_data['search']));
			$this->db->group_end();
		}

		if($where_data['start_date'] != "" && $where_data['end_date'] != ""){
			$this->db->where('of_created_on >=',$where_data['start_date']);
			$this->db->where('of_created_on <= ',$where_data['end_date']);
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('of_id','of_plan_name','of_user_email','of_geography','of_activation_code')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('of_id','desc');
			}
		}

		$this->db->group_by('of_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	
	}

	// get offers
	
	public function getalloffers($type,$where_data){
		$table = "plans";
		if($type=='data')
		{
			$this->db->select('pl_id,pl_name,pl_banner_status,pl_offer_price');   
		}
		else
		{
			$this->db->select('pl_id');		
		}
		$this->db->where('pl_banner_status !=','');
		$this->db->where('pl_delete_status','0');
		$this->db->from($table);
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('pl_name', addslashes($where_data['search']));			
			$this->db->group_end();
		}

		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];

			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}

			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pl_id','pl_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('pl_id','desc');
			}
		}

		$this->db->group_by('pl_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		//print_r($this->db->last_query());die;
		return $result;	
	}

	public function getOfferDetails(){
		if($this->uri->segment(2) !="" && $this->uri->segment(2) >0){
			$this->db->select('pl_id,pl_prop_type,pl_name,pl_banner_status,pl_offer_price');
			$this->db->where('pl_id',$this->uri->segment(2));
			$res = $this->db->get('plans');
			return $res->row();
		}else{
			return 0;
		}
		
	}

	public function add_offer(){
		if($this->input->post('show_on_banner') != ""){
			$bannerStatus = $this->input->post('show_on_banner');
		}else{
			$bannerStatus = '';
		}
		$data = array('pl_banner_status' =>$bannerStatus, 'pl_offer_price' => $this->input->post('offer_price'));
		$this->db->where('pl_id',$this->input->post('plan_name'));
		$res = $this->db->update('plans',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	} 

	public function delete_offer(){
		$data = array('pl_banner_status' => "", 'pl_offer_price' => "0.00");
		$this->db->where('pl_id',$this->input->post('new_id'));
		$res = $this->db->update('plans',$data);
		if($res){
			return true;
		}else{
			return false;
		}
	}

	public function getwebsiteinventoryreport($type,$where_data){
		$table = "plans";
		if($type=='data')
		{
			$this->db->select("pl_name,pl_prop_type,sp_name,country_name,r_name,i_plan_id, count(CASE WHEN i_code_available_status = 'Y' THEN 1 END) as available_cnt,
				count(CASE WHEN i_code_available_status = 'T' THEN 1 END) as transferred_cnt,
				count(CASE WHEN i_code_available_status = 'S' THEN 1 END) as sold_cnt,
				count(CASE WHEN i_code_available_status = 'N' THEN 1 END) as not_available_cnt");   
		}
		else
		{
			$this->db->select('pl_id');		
		}
		$this->db->where('i_delete_status','0');
		$this->db->where('pl_delete_status','0');
		$this->db->from($table);
		$this->db->join('inventory','pl_id = i_plan_id');
		$this->db->join('suppliers','sp_id = pl_supplier');
		$this->db->join('country','country_id=pl_country','left');
		$this->db->join('regions','r_id=pl_region','left');
		if(isset($where_data['search']) && $where_data['search'] != '')
		{	
			$this->db->group_start();
			$this->db->like('pl_name', addslashes($where_data['search']));			
			$this->db->group_end();
		}
		//pagination and sorting
		if(isset($where_data['per_page']) && $type == 'data')
		{
			$limit = $where_data['per_page'];
			if($where_data['page'] != 0)
			{
				$page = --$where_data['page'];
			}
			else
			{
				$page = $where_data['page'];
			}
			$this->db->limit($limit, $page*$limit);
		}

		if(isset($where_data['sort_by']) && $type == 'data')
		{
			// Set sorting
			if($where_data['sort_by'] != '' && $where_data['sort_direction'] != '')
			{				
				if(in_array($where_data['sort_by'], array('pl_id','pl_name')))
				{
					$this->db->order_by($where_data['sort_by'],$where_data['sort_direction']);
				}
			}
			else
			{
				// Set default sorting
				$this->db->order_by('i_plan_id','desc');
			}
		}

		$this->db->group_by('i_plan_id');
		
		// If data is required
		if($type == 'data')
		{
			$result = $this->db->get()->result_array();			
		}   
		else
		{
			$result = $this->db->get()->num_rows();			
		}
		return $result;	
	}

	public function no_of_active_plans(){
		$result = $this->db->select('pl_id')->where('pl_delete_status','0')->get('plans')->num_rows();
		return $result;
	}
	public function no_of_orders(){
		$result = $this->db->select('pm_id')->get(' payments')->num_rows();
		return $result;
	}
	public function no_of_enquiries(){
		$result = $this->db->select('eq_id')->where('eq_deleted_status','0')->get('enquiries')->num_rows();
		return $result;
	}
	public function no_of_inventoty(){
		$result = $this->db->select('i_id')->where('i_delete_status','0')->get('inventory')->num_rows();
		return $result;
	}

	public function send_order_mail(){
		
		//if($this->input->post('id') != ""){
			$order_id = '1731904888';
			$config = array(
				'protocol'     => 'smtp',
				'smtp_host'    => 'ssl://smtp.gmail.com',
				'smtp_port'    => '465',
				'smtp_user'    => 'digitalpatti@gmail.com',
				'smtp_pass'    => 'vkqdmnpjbsfqrsoq',
				'mailtype'     => 'html',
				'wordwrap'     => TRUE
			);
			$response_data = $this->db->where('o_order_id',$order_id)->get('orders')->result_array();
			if($response_data !="" && sizeof($response_data) >0){
				$this->email->initialize($config);
				$this->email->set_header('MIME-version','1.0;charset=utf-8');
				$this->email->set_mailtype('html');
				$this->email->to($response_data[0]['o_user_email']);
				$this->email->subject("Esimzon E-Sim QR Code - Order ID - ".$order_id);
				$data = [];
				$data['subject'] = 'An exquisite esim experience for travellers';
				$data['customer_name'] = $response_data[0]['o_user_name'];
				$data['response_data'] = $response_data;
				$data['support_email'] = "support@esimzon.com";
				$data['support_number'] = "2343245346";
				
				//$qrcode = base_url().'assets/images/qrcodes/'.$response_data[];
				//$this->email->attach($logo, 'inline', 'logo.png', 'image/png');
				//$this->email->attach($qrcode, 'inline', 'qrcode.png', 'image/png');
				
				$message = $this->load->view('email/order_confirmation_email',$data,true);
				//print_r($message);die; 
				$this->email->message($message);
				$this->email->set_newline("\r\n");
				$this->email->from('noreply@esimzon.com', "Esimzon Team");
				
				if(!$this->email->send()){
					echo $this->email->print_debugger();
					return false;
				}else{
					echo 'done';
				}
				
			}else{
				return false;
			}
		// }else{
		// 	return false;
		// }
	}
}
?>