<?php

class User_model extends CI_Model{

    public function getUserDetails($id){
        $this->db->where('u_id',$id);
        $this->db->where('u_type','0');
        $rest = $this->db->get('users');
        return $rest->row();
    }

    public function update_user_profile($image){
		$id = $this->session->userdata('id');

        $this->db->select('u_profile_image');
        $this->db->where('u_id',$id);
        $this->db->where('u_type','0');
        $rest = $this->db->get('users');

        if($image == ""){
            $image = $rest->row()->u_profile_image;
        }

		if($id != ""){
			$data = array('u_name'		    => $this->input->post('user_name'),
					      'u_contact'	    => $this->input->post('user_contact'),
					      'u_profile_image'	=> $image
					);
			$this->db->where('u_id',$id);
			$res  = $this->db->update('users',$data);
			if($res){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
		
	}

    public function add_ticket(){
        $userid = $this->session->userdata('id');
        
        $data = array('t_complaint' => $this->input->post('tc_category'),
                      't_sub_complaint' => $this->input->post('tc_sub_category'),
                      't_esim_iccid' => $this->input->post('tc_iccid_esim_no'),
                      't_remarks' => $this->input->post('tc_remarks'),
                      't_user_id' => $userid);

        $res = $this->db->insert('tickets',$data);
        if($res){
            return true;
        }else{
            return false;
        }
    }

    public function getAllUserTickets(){
		$table = "tickets";
		
		$this->db->select('*'); 
		$this->db->where('t_delete_status','0');
        $this->db->where('t_user_id',$this->session->userdata('id'));
		$this->db->from($table);
		$this->db->join('complaints','t_complaint=cm_id');
		$this->db->join('sub_complaints','t_sub_complaint=sc_id','left');
		$this->db->order_by('t_id','desc');
		
		$result = $this->db->get()->result();	
		return $result;	
	}

    public function getOrderhistory(){
        $id = $this->session->userdata('id');
        $this->db->where('o_user_id',$id);
        $this->db->where('o_expiry_date <',date('Y-m-d'));
        $rest = $this->db->get('orders');
        return $rest->result();
    }

    public function getMyesims(){
        $id = $this->session->userdata('id');
        $this->db->where('o_user_id',$id);
        $this->db->where('o_expiry_date >=',date('Y-m-d'));
        $rest = $this->db->get('orders');
        return $rest->result();
    }

    public function updatePlanStatus(){
        $id = $this->session->userdata('id');
        $data = array('o_status' => '1');
        $this->db->where('o_expiry_date <',date('Y-m-d'));
        $res = $this->db->update('orders',$data);
        if($res){
            return true;
        }else{
            return false;
        }
    }
}

?>