<?php $this->load->view('admin/header'); ?>
<div class="content">
    <div class="row">
        <div class="col-md-12">
            <h4 class="left">Partner</h4>
            <a href="<?=base_url();?>admin-add-partner" class="btn btn-info right mt-30">Add Partner</a>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title"> Partner List</h4>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-lg-9">
                            <div class="d-block d-md-inline-block w-100">
                                <div class="search-sm d-inline-block float-md-left mr-1 mb-1 align-top w-100">
                                    <input class="form-control" id="txt_search" value="<?= $search !=='' ? $search :'' ?>" placeholder="Search Table" id="searchDatatable01">
                                </div>
                            </div>
                        </div>
                        <div class="col-lg-3">
                            <!-- <div class="perpage_label">Per Page</div> -->
                            <select class="form-control w-40 perpage" data-placeholder="- Select Per Page -" id="per_page_value">
                               
                                <option value="20" <?php if($per_page=='20'){ echo 'selected'; } ?>>20</option>
                                <option value="50" <?php if($per_page=='50'){ echo 'selected'; } ?>>50</option>
                                <option value="100" <?php if($per_page=='100'){ echo 'selected'; } ?>>100</option>
                                <option value="500" <?php if($per_page=='500'){ echo 'selected'; } ?>>500</option>
                                <option value="<?php if($per_page==''){ echo 'selected'; } ?>">All</option>
                            </select>
                        </div>
                    </div>
                    <div class="table-responsive" id="ajax_data">
                        <?php $this->load->view('admin/partner_ajax'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- The inventory transfer Modal -->
<div class="modal fade inventory_transfer" id="inventory_transfer">
    <div class="modal-dialog">
        <div class="modal-content">
        
            <!-- Modal Header -->
            <div class="modal-header">
            <h4 class="modal-title">Transfer Inventory</h4>
            <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            
            <!-- Modal body -->
            <form class="share_activation_code_form" id="share_activation_code_form" method="post">
                <div class="modal-body">
                    <div class="form-group">
                        <label>Property Type</label>
                        <div class="row">
                            <label class="container custom-checkbox checked">Local
                                <input type="radio" name="p_type_local" value="1" checked>
                            </label>
                            <label class="container custom-checkbox">Roaming
                                <input type="radio" name="p_type_local" value="2">
                            </label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label>Select Plan</label>
                        <select name="each_plan_name" class="form-control select2" id="each_plan_name">
                            <option value="">Select </option>
                            <?php if(isset($plans) && $plans !=""){
                                foreach($plans as $each_plan){ ?>
                                    <option value="<?=$each_plan->pl_id;?>"><?=ucfirst($each_plan->pl_name);?></option>
                                <?php }
                            } ?>
                        </select>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>Supplier</label>
                                <select name="each_plan_supplier_name" class="form-control" id="each_plan_supplier_name" readonly>
                                    <option value=""></option>
                                </select>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group" id="local_country">
                                <label>Country</label>
                                <select name="each_plan_country_name" class="form-control" id="each_plan_country_name" readonly>
                                    <option value=""></option>
                                </select>
                            </div>
                            <div class="form-group" id="roaming_region">
                                <label>Region</label>
                                <select name="each_plan_region_name" class="form-control" id="each_plan_region_name" readonly>
                                    <option value=""></option>
                                </select>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>Buying Cost</label>
                                <div class="input-group">
                                    <input type="text" name="each_plan_cost" id="each_plan_cost" class="form-control error_placement" value="" readonly>
                                    <div class="input-group-append">
                                        <select class="form-control add_on_select" name="each_plan_cost_currency" readonly>
                                            <option value="">Select</option>
                                            <option value="1" selected>$</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>Selling Cost</label>
                                <div class="input-group">
                                    <input type="text" name="selling_cost" id="selling_cost" class="form-control">
                                    <div class="input-group-append">
                                        <select class="form-control add_on_select" name="selling_cost_currency">
                                            <option value="">Select</option>
                                            <option value="1" selected>$</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>                   
                    <div class="form-group">
                        <label>Quantity</label><span id="available_code" class="right"></span>
                        <select name="code_quantity" class="form-control" id="code_quantity">
                            <option value="">select</option>
                            <?php for($i=1; $i<=25; $i++){ ?>
                                <option value="<?=$i;?>"><?=$i;?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <p> <input type="checkbox" id="checkAll" name="" value="assign_all"> <label>Assign All</label> 
                        <span class="right">Activation Code</span>
                    </p>
                    <hr>
                    <div class="row" id="activation_data"></div>
                    
                    <input type="hidden" id="partner_id" name="partner_id" value="">
                </div>
                
                <!-- Modal footer -->
                <div class="modal-footer">
                <button type="submit" class="btn btn-info">Transfer</button>
                </div>
            </form>
        </div>
    </div>
</div>
<!-- Modal end -->

<!-- The view inventory Modal -->
<div class="modal fade view_inventory" id="view_inventory">
    <div class="modal-dialog">
        <div class="modal-content">
        
            <!-- Modal Header -->
            <div class="modal-header">
            <h4 class="modal-title text-center"> Inventory List</h4>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            
            <!-- Modal body -->
            <div class="modal-body">
                <table class="table">
                    <thead>
                        <th>Sno.</th>
                        <th>Plan</th>
                        <th>Activation Code</th>
                        <th>Status</th>
                        <!-- <th>Action</th> -->
                    </thead>
                    <tbody id="inventory_data">
                        <td></td>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
<!-- Modal end -->
<?php $this->load->view('admin/footer'); ?>

<script type="text/javascript">
  
///////// PAGINATION SCRIPT START
    $("body").on("click",'ul.pagination li a.paginate_button',function(e)
    {
        e.preventDefault();

        if($(this).attr('href') && $(this).attr('href')!="#" && !$(this).hasClass("disabled"))
        {
            $('#pagination_url').val($(this).attr('href'));

            $('#pagination_page').val('');

            page_value = $(this).attr('page_number');

            if(page_value!="" && page_value!=undefined)
            {
                change_search_data("page",page_value)
            }

            page_update();
        }

        return false;
    });
function page_update()
{
    $.ajax({
        url: $('#pagination_url').val() + $('#pagination_page').val(),
        type: 'POST',
        data:{ 
            'request'                   : 'ajax', 
            'sort_by'                   : $('#pagination_sort_by').val(), 
            'sort_direction'            : $('#pagination_sort_direction').val(), 
            'per_page'                  : $('#per_page_value').val(),
            'search'                    : $.trim($('#txt_search').val()),
        },
        beforeSend: function()
        {
            $(".main-loader").show();
        },      
        complete:function()
        {
            $(".main-loader").hide();
        },
        success: function( data )
        {
            $('#ajax_data').html(data);
            //$("#form_data").load(location.href + " #form_data");           
        },
    });
}
</script>
<script type="text/javascript">

  $(document).ready(function(){
  var base = $('#base_url').val();
              $('[data-toggle="tooltip"]').tooltip();

    $("a.sorting").each(function(){
        if($("#pagination_sort_by").val() == $(this).attr('sort-by') )
        {
            if($("#pagination_sort_direction").val() == 'asc' )
            {
                $(this).addClass('sort-asc');

                $(this).attr('sort-order','desc')
            }
            else if($("#pagination_sort_direction").val() == 'desc' )
            {
                $(this).addClass('sort-desc');

                $(this).attr('sort-order','asc')

            }
        }
    })
    //SEARCH SUBMIT BUTTON EVENT
    $("body").on("keyup", '#txt_search',function(e)
    { 
        $('#pagination_page').val(1);
        change_search_data("page",1);
        change_search_data('request', 'ajax');   
        change_search_data("search",$.trim($('#txt_search').val()));
             
        page_update();
        return false;
    });
    //SORTING
        $("body").on("click",'a.sorting[sort-by]',function(e)
        {
            $('#pagination_sort_by').val($(this).attr("sort-by"))
            $('#pagination_sort_direction').val($(this).attr("sort-order"))
            $('#pagination_page').val(1);
            change_search_data("page",1)
            change_search_data("sort_direction",$('#pagination_sort_direction').val())
            change_search_data("sort_by",$('#pagination_sort_by').val())
            page_update();
            return false;
        });

          $("body").on("click",'#reset-btn',function(){
       
       window.location.href='<?php echo base_url(); ?>admin-partner';
        return false;
      });
  });
</script>

<script type="text/javascript">
  function delete_partner(id){
    var new_id = id;
    var base = $('#base_url').val();
    if(confirm('Do you really want to perform this action ?')){
       $.ajax({
                  url: base+'Home_controller/delete_partner',
                  type:'post',
                  data: {new_id:new_id},
                  dataType: 'json',
                  
                  success: function(response){
                      if(response==true){
                        toastr.success('Your partner has been deleted successfully','Success',{timeOut:5000});
                       
                        page_update();
                      }else{
                        toastr.error('Please try again later','Failed',{timeOut:5000});
                      }
                  }
             });
        }
  }
</script>
<script>
    function transfer_inventory(id){
        $('#partner_id').val(id);
        $('#inventory_transfer').modal('show');
    }
</script>
<script>
    function view_inventory(id){
        var base = $('#base_url').val();
        $.ajax({
                url: base+'Home_controller/view_inventory',
                type:'post',
                data: {partner_id:id},
                dataType: 'json',
                
                success: function(response){
                    if(response != ""){
                        var str = '<tr>';
                        for(var i=0;i<response.length;i++){
                            var u_str = response[i].pl_name.toLowerCase().replace(/\b[a-z]/g, function(letter) {
                                return letter.toUpperCase();
                        });
                            var status = "";
                            if(response[i].i_code_available_status == 'T'){
                                status = 'Transferred';
                            }else if(response[i].i_code_available_status == 'S'){
                                status = "Sold";
                            }else if(response[i].i_code_available_status == 'Y'){
                                status = "Available";
                            }else{
                                status = "Not Available";
                            }
                            str+= '<td>'+i+'</td><td>'+u_str+'</td><td>'+response[i].i_activation_code+'</td><td>'+status+'</td></tr>';
                        }
                        $('#inventory_data').html(str);
                    }else{
                        $('#inventory_data').html('<td colspan="4">No data found!</td>');
                    }
                    
                    $('#view_inventory').modal('show');
                }
             }); 
        
    }
</script>
<script type="text/javascript">
    $(document).ready(function() { 
        var base = $('#base_url').val();
        $('#roaming_region').hide();

        $(document).on('change','.custom-checkbox input',function(){
            var id = $(this).val();
            $('.custom-checkbox').removeClass('checked');
            if($(this).is(':checked')){
                $(this).parent('.custom-checkbox').addClass('checked');
            }else{
                $(this).parent('.custom-checkbox').removeClass('checked');
            }

            if(id == 1){
                $('#roaming_region').hide();
                $('#local_country').show();
            }else if(id== 2){
                $('#roaming_region').show();
                $('#local_country').hide();
            }

            var str ="<option value=''>Select</option>";
            $.ajax({
                url: base+'Home_controller/getPlanListByPropertyType',
                type:'post',
                data: {id:id},
                dataType: 'json',
                success: function(response){
                    if(response!=""){
                        for(var i=0;i<response.length;i++){
                            var u_str = response[i].pl_name.toLowerCase().replace(/\b[a-z]/g, function(letter) {
                                return letter.toUpperCase();
                        });
                            str+= '<option value="'+response[i].pl_id+'">'+u_str+'</option>';
                        }
                    }
                    $('#each_plan_name').html(str);
                    $('#each_plan_supplier_name').html("<option value=''>Select</option>");
                    $('#each_plan_country_name').html("<option value=''>Select</option>");
                    $('#each_plan_cost').val("");
                }
        
            });
        });

    });
</script>
<script>
    $(document).ready(function(){
        var base = $('#base_url').val();
        $(document).on('change','#each_plan_name',function(){
            var id = $(this).val();
            var str = u_strr1 = "";
            var supplier = country = region = "";
            $.ajax({
                    url: base+'Home_controller/get_supplier_country_cost_by_plan',
                    type:'post',
                    data: {id:id},
                    dataType: 'json',
                    success: function(response){
                        console.log(response);
                        if(response!=""){

                            str = response['pl_buying_cost']+" $";
                            var u_str1 = response['sp_name'].toLowerCase().replace(/\b[a-z]/g, function(letter) {
                                    return letter.toUpperCase(); });
                            supplier = "<option value='"+response.sp_id+"'>"+u_str1+"</option>";
                            
                            country = "<option value='"+response.country_id+"'>"+response['country_name']+"</option>";
                            
                           
                            region = "<option value='"+response.r_id+"'>"+response['r_name']+"</option>";
                        }
                        console.log(u_str1);
                        $('#each_plan_supplier_name').html(supplier);
                        $('#each_plan_country_name').html(country);
                        $('#each_plan_region_name').html(region);
                        $('#each_plan_cost').val(str);
                    }
            
                });
        });
    });
</script>
<script>
    $(document).ready(function(){
        $('#activation_data').hide();
        var base = $('#base_url').val();
        $("#checkAll").change(function () {
            $("input:checkbox").prop('checked', $(this).prop("checked"));
        });
        $(document).on('change','#code_quantity',function(){
            var id = $(this).val();
            var plan_id = $('#each_plan_name').val();
            var str ="";
            $.ajax({
                url: base+'Home_controller/getInventoryListByPlan',
                type:'post',
                data: {id:id,plan_id:plan_id},
                dataType: 'json',
                success: function(response){
                    
                    if(response.length > 0){
                        if(response.length >= $('#code_quantity').val()){
                            for(var i=0;i<response.length;i++){
                                str+= '<div class="col-md-6 activation_code_list"><div class="form-group"><input type="checkbox" class="" name="activation_code[]" value="'+response[i].i_id+'"><label>'+response[i].i_activation_code+'</label></div></div>';
                            }
                        }else{
                            toastr.error('You cannot select more than '+response.length+' quantity.');
                        }
                        
                    }else{
                        str = "<p class='text-center'>No activation code available</p>"
                    }
                    //$('#available_code').html('Available Codes ('+response.length+')');
                    $('#activation_data').html(str);
                    $('#activation_data').show();
                }
        
            });
        });

        // $(document).on('change','#code_quantity', function(){ 
        //     var num = $(this).val();
        //     if(!$('#activation_code_list').hasClass('hide')){
        //         $('#activation_code_list').addClass('hide');
        //     }
        //     $(".activation_code_list").slice(0, num).each(function(index) {
        //                 $(this).removeClass('hide');
        //     });
        //     //$('activation_data .activation_code_list:lt('+num+')').show();
        // });
    });

    $(document).ready(function(){
        //form submit
        var base = $('#base_url').val();
        $('#share_activation_code_form').validate({
            rules:{
                'selling_cost':{
                    required: true
                },
                'activation_code':{
                    required: true
                }
            },
            messages:{
                'selling_cost':{
                    required:'selling cost is required!'
                },
                'activation_code':{
                    required:'Activation code is required!'
                }
            },
            submitHandler:function(form){
            
                var formdata = new FormData(form);
                $('#share_activation_code_form')[0].reset();
                $.ajax({
                    url: base+'Home_controller/send_code_with_partner',
                    type:'post',
                    data: formdata,
                    processData: false,
                    contentType: false,
                    dataType: 'json',
                    success: function(response){
                        if(response==true){
                            setTimeout(function(){
                                window.location.reload();
                                }, 2000);
                            toastr.success('Activation code has been transfered successfully','Success',{timeOut:5000});
                            $( '#share_activation_code_form' ).each(function(){
                                this.reset();
                            });
                        
                        }else{
                            toastr.error('Please try again later','Failed',{timeOut:5000});
                        }
                    }
            
                });
            }
        });
  
    });
</script>