<!-- Tickets List -->
<p class="lead mb-4">Tickets
    <a href="javascript:void(0);" class="btn btn-warning right" data-toggle="modal" data-target="#addTicketModal">Add New Ticket </a>
</p>

<div class="mt-4 pt-2 overflow-auto">
    <table class="table">
        <thead>
            <tr>
                <th>Sno.</th>
                <th>Ticket No.</th>
                <th>Category</th>
                <th>Sub-category</th>
                <th>Esim No. / ICCID</th>
                <th>Remarks</th>
                <th>Date</th>
                <th>Status</th>
            </tr>
        </thead>
        <tbody>
            <?php if($tickets != "" && sizeof($tickets) > 0){ $i = 1;
                    foreach($tickets as $each_ticket){ ?>
                        <tr>
                            <td><?=$i;?></td>
                            <td><?='TC100'.$each_ticket->t_id;?></td>
                            <td><?=ucfirst($each_ticket->cm_comp);?></td>
                            <td><?=ucfirst($each_ticket->sc_subComp);?></td>
                            <td><?=$each_ticket->t_esim_iccid;?></td>
                            <td><?=$each_ticket->t_remarks;?></td>
                            <td><?=date('d-m-Y',strtotime($each_ticket->t_createdOn));?></td>
                            <td><?php if($each_ticket->t_ticket_status == 'Pending'){
                                $badgeClass = 'btn-warning';
                            }else if($each_ticket->t_ticket_status == 'Cancelled'){
                                $badgeClass = 'btn-danger';
                            }else if($each_ticket->t_ticket_status == 'Closed'){
                                $badgeClass = 'btn-success';
                            }else if($each_ticket->t_ticket_status == 'Open'){
                                $badgeClass = 'btn-info';
                            } ?>
                                <button class="btn btn-sm <?=$badgeClass?>"><?=$each_ticket->t_ticket_status;?></button></td>
                        </tr>
                    <?php $i++; }
                }else{ ?>
                    <tr><td class="text-center" colspan="8">No Data Found!</td></tr>
                <?php }  ?>
        </tbody>
    </table>
</div>
<!-- Add ticket modal -->
<div class="modal fade" id="addTicketModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-body">
                <h3 class="lead text-center mt-4 pt-4">Add Ticket</h3>
                <div class="ticket-box">
                    <form method="post" id="addTicketForm" class="mb-4">
                        <div class="form-group mb-3">
                            <label class="mb-1"> Category </label>
                            <select class="form-control" name="tc_category" id="tc_category">
                                <option value="">Select</option>
                                <?php if(!empty($complaint_list) && $complaint_list!=""){
                                    foreach($complaint_list as $list){ ?>
                                    <option value="<?=$list->cm_id; ?>">
                                        <?=ucfirst($list->cm_comp); ?>
                                    </option>
                                    <?php }
                                } ?>
                            </select>
                        </div>
                        <div class="form-group mb-3">
                            <label class="mb-1"> Sub Category </label>
                            <select class="form-control" name="tc_sub_category" id="tc_sub_category">
                                <option value="">Select</option>
                            </select>
                        </div>
                        <div class="form-group mb-3">
                            <label class="mb-1"> Esim Number / ICCID  </label>
                            <input type="text" name="tc_iccid_esim_no" class="form-control">
                        </div>
                        <div class="form-group mb-3">
                            <label class="mb-1"> Remarks  </label>
                            <textarea name="tc_remarks" class="form-control" rows="4"></textarea>
                        </div>
                        <button type="submit" class="btn btn-primary btn-custom">Submit</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>